<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Illuminate\Database\QueryException;
;
use Validator;
use DB;
use App\Mail\DemoEmail;
use App\Http\Libraries\firebase\PushMessageCustom;
use Illuminate\Support\Facades\Mail;
use Stripe;
use Omnipay\Omnipay;
use App\Settings_model;
use App\DeviceInfo;
use App\Stripes;
use App\Paypals;
use App\User;
use App\User_payment;
use App\DeviceOrders;


/* https://stackoverflow.com/questions/18505793/how-to-do-a-capture-after-an-authorize-and-how-to-do-a-refund-in-omnipay */
class PaymentController extends Controller
{
    public function __construct(){
        DB::enableQueryLog();
        $paypal_obj     = new Paypals();
        $paypal_record  = $paypal_obj->get()->toArray();
        $this->gateway  = Omnipay::create('PayPal_Rest');
        $this->gateway->setClientId($paypal_record[0]['api_username']);
        $this->gateway->setSecret($paypal_record[0]['api_secret']);
        $this->gateway->setTestMode(true); //set it to 'false' when go live
        if($paypal_record[0]['mode'] === 'live'){
            $this->gateway->setTestMode(false); //set it to 'false' when go live
        }
        
        
        //Live detail
        //Userid :  AXdX0ayDNM5Mi1lmdgsA4D_B155AXPALs6xC-Fs-nbZ2g9XGcFIzn50pbHx1pi7d4gvNklAPmlxmdGPZ
        //secret : EGjHF2B8pyBk1r0EQzeKL_X6XFTg_QaslzSOaPNK0TCuujBpJ6MKyRhwEMHRulDvke1KkkSeqATuqS9Z
    }
    
    /* Paypal payment start */
    public function paypalAuth(){
        $payload = json_encode(array(
            "intent"=>"authorize",
            "payer"=>array(
                "payment_method" => "paypal",
            ),
            "transactions" => array(
                "amount" => array(
                    "total"=>"30.11",
                    "currency"=>"USD",
                    "details" => array()
                ),
                "description"=>3223,
            ),
            "redirect_urls" => array(
                'cancelUrl' => url('updateKioskCancel'),
                'returnUrl' => url('updateKioskSuccess'),
            ),
        ));
        
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();
        
        curl_setopt($ch, CURLOPT_URL, 'https://api-m.sandbox.paypal.com/v1/payments/payment');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload );
        $headers = array();
        $headers[] = 'Content-Type: application/json';
        //$headers[] = 'Authorization: Bearer <Access-Token>';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        
        curl_close($ch);
        print_r($result);die;
    }
    
    
    public function kioskPaypal(Request $request,$OrderId,$userId,$amount){
        if(!empty($OrderId) && !empty($amount) && !empty($userId)){
            $orderid    = (int)$OrderId;
            $userId     = (int)$userId;
            $amount     = (float)$amount;
            
            $userExist  = User::where('id',$userId)->count();
            $orderExist = DeviceOrders::where('order_id',$orderid)->where('deposit_amount',$amount)->count();
            if($orderExist && $userExist){
                $userInfo = User::select('email')->where('id',$userId)->first();
                $response = $this->gateway->authorize(
                    array(
                        'cancelUrl' => url('updateKioskCancel'),
                        'returnUrl' => url('updateKioskSuccess'),
                        'amount' => $amount,
                        'currency' => 'EUR'
                    )
                )->send();

                $response->redirect();

                // $transaction = $this->gateway->authorize(array(
                //   'amount'        => '10.00',
                //   'currency'      => 'AUD',
                //   'description'   => 'This is a test authorize transaction.',
                //   'intent' => 'authorize',
                //   'returnUrl' => url('updateKioskSuccess'),
                //   'cancelUrl' => url('updateKioskCancel'),
                // ));
                // $response = $transaction->send();
                // if ($response->isSuccessful()) {
                //   echo "Authorize transaction was successful!\n";
                //   // Find the authorization ID
                //   $auth_id = $response->getTransactionReference();
                //   echo $auth_id;die;
                // }
            
            }else{
                echo json_encode(array('error'=>'Invalid Order'));
            }
        }else{
            echo json_encode(array('error'=>'Invalid Info provided'));
        }
    }
    
    public function updateKioskSuccess(Request $request){
        print_r($_REQUEST);die;
        // echo $request->input('PayerID');
        // echo '<=><br><=>';
        // echo $request->input('paymentId');
        $transaction = $this->gateway->completePurchase(array(
            'payer_id'             => $request->input('PayerID'),
            'transactionReference' => $request->input('paymentId')
        ));
        $response = $transaction->send();
        if ($response->isSuccessful()) {
            $arr_body = $response->getData();
            echo "<pre>";print_r($arr_body);die;
            // The customer has successfully paid.
            echo "Step 4 was successful!\n";
        } else {
            echo "Step 4 was unsuccessful!\n";
            // There was an error returned by completePurchase().  You should
            // check the error code and message from PayPal, which may be something
            // like "card declined", etc.
        }
        
   }   
   
   
    public function updateKioskSuccess1(Request $request){
        
        $transaction = $this->gateway->completePurchase(array(
            'payer_id'             => '3U5ZHSDH2FS6C',
            'transactionReference' => 'MAX22DQ4B800387VD234910C',
            'amount' => '2.00',
            'currency' => 'EUR'
        ));
        $response = $transaction->send();
        if ($response->isSuccessful()) {
            $arr_body = $response->getData();
            echo "<pre>";print_r($arr_body);die;
            // The customer has successfully paid.
            echo "Step 4 was successful!\n";
        } else {
            echo "Step 4 was unsuccessful!\n";
            // There was an error returned by completePurchase().  You should
            // check the error code and message from PayPal, which may be something
            // like "card declined", etc.
        }
   }   
    
    public function updateKioskCancel(){
      $message = trans('messages.Payment Cancelled');
      echo json_encode(array('error'=>$message));
	}
    /* Paypal payment finish */
    
    
    /* Stripe payment start */
    public function stripe(Request $request,$OrderId,$userId,$amount){
        if(!empty($OrderId) && !empty($amount) && !empty($userId)){
            $orderid = (int)$OrderId;
            $userId  = (int)$userId;
            $amount  = (float)$amount;

            $userExist  = User::where('id',$userId)->count();
            $orderExist = DeviceOrders::where('order_id',$orderid)->where('deposit_amount',$amount)->count();
            if($orderExist && $userExist){
                $setting_obj   = new Settings_model();
                $settingInfo   = $setting_obj->select('value')->where('attribute','Currency')->first();
            
                if(is_float($amount)){
                    $Stripes_obj            = new Stripes();
                    $stripe_record          = $Stripes_obj->get()->toArray();
                    $data['kd']             = $orderid;
                    $data['ud']             = $userId;
                    $data['amt']            = $amount;
                    $data['crn']            = $settingInfo->value;
                    $data["STRIPE_KEY"]     = $stripe_record[0]["stripe_key"];
                    $data["STRIPE_SECRET"]  = $stripe_record[0]["stripe_secret"];
                    return view('stripe')->with(array("data"=>$data));
                }else{
                    echo json_encode(array('error'=>'Invalid amount'));
                }
            }else{
                echo json_encode(array('error'=>'Invalid Order'));
            }
        }else{
            echo json_encode(array('error'=>'Invalid Info provided'));
        }
    }
    
    public function stripePost(Request $request){
        $kd         = $request->kd;
        $ud         = $request->ud;
        $userExist  = User::where('id',$ud)->count();
        $orderExist = DeviceOrders::where('order_id',$kd)->count();
        if($orderExist && $userExist){
            $orderInfo  = DeviceOrders::select('deposit_amount')->where('order_id',$kd)->first();
            try{
  	            //Stripe\Stripe::setApiKey(env('STRIPE_SECRET'));
  	            $Stripes_obj   = new Stripes();
                $stripe_record = $Stripes_obj->get()->toArray();
                Stripe\Stripe::setApiKey($stripe_record[0]["stripe_secret"]);
         	
                $amt           = $orderInfo->deposit_amount;
	            $description   = 'Power bank battery deposit amount'; 
   	            
   	            $charge = Stripe\Charge::create ([
                    "amount" => 100 * $amt,
                    "currency" => "eur",
                    "source" => $request->stripeToken,
                    "description" => $description,
                    'capture' => false,
                    'metadata' => array(
                        'kiosk_id' => $kd,
                        'user_id' => $ud,
                    )
                ]);
         	    
       	        /* If payment is success */
       	        $chargeJson = $charge->jsonSerialize();
       	        if(!empty($chargeJson['id'])){
                    $charge_id             = $chargeJson['id'];
                    /* Update in order table */
                    $charge_date = Defaults::getDate();
                    DeviceOrders::where('order_id',$kd)->update(['payment_type'=>'Stripe','charge_id'=>$charge_id,'charge_date'=>$charge_date]);
                   
                   
                    //     $update_array = array(
                    //       "user_id" =>$user_id,"kiosk_id" =>$kiosk_id,
                    //       "transaction_id" => $balance_transaction,'payment_type'=>'Stripe'
                    //       ,"payment_date"=>$current_date,"payment_status"=>1);
                       
                    //   User_payment::insert($update_array);
                   return redirect('orderStripeSuccess');
                }else{
                   //echo 'fsf';
                   return redirect('orderStripeCancel');
                }    
            }catch(Stripe\Exception\CardException $e) {
           		$message =  $e->getError()->message;
                $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
          		return redirect("stripe/".$od.'/'.$amt);
     	    }    
        }else{
            //echo 'invalid';
            return redirect('orderStripeCancel');
        }
    }
    
    public function orderStripeSuccess(){
        echo json_encode(array('error'=>'Payment Captured succesfully'));
    }
    
    public function orderStripeCancel(){
        echo json_encode(array('error'=>trans('messages.went_wrong')));
    }
}