<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Illuminate\Database\QueryException;
;
use Validator;
use DB;
use App\Mail\DemoEmail;
use App\Http\Libraries\firebase\PushMessageCustom;
use Illuminate\Support\Facades\Mail;
use Stripe;
use Omnipay\Omnipay;
use App\Settings_model;
use App\DeviceInfo;
use App\Stripes;
use App\User;
use App\User_payment;

class PaymentController extends Controller
{
   public function __construct(){
      DB::enableQueryLog();
      $this->gateway = Omnipay::create('PayPal_Rest');
      $this->gateway->setClientId('AYV7BpoT8oBVfr5HexjzY-n6_zmUIJp2zbPCy3PUbbgJyNRvd_vSECwb2G1hsyabS_kyYjymvvXhzCJJ');
      $this->gateway->setSecret('EHZB66Q3K4i9M1CTasnitglXHOeiekIikOjAUSiSbjcka57-A7-Jbl_xETvMxAZRvQByqN1Ux01ln3kW');
      $this->gateway->setTestMode(true); //set it to 'false' when go live
        
      //Live detail
      //Userid :  AXdX0ayDNM5Mi1lmdgsA4D_B155AXPALs6xC-Fs-nbZ2g9XGcFIzn50pbHx1pi7d4gvNklAPmlxmdGPZ
      //secret : EGjHF2B8pyBk1r0EQzeKL_X6XFTg_QaslzSOaPNK0TCuujBpJ6MKyRhwEMHRulDvke1KkkSeqATuqS9Z
   }
    
   /* Paypal payment start */
   public function kioskPaypal(Request $request,$userId,$kioskId,$amount){
      if(!empty($kioskId) && !empty($amount) && !empty($userId)){
         $kioskId = (int)$kioskId;
         $userId  = (int)$userId;
         $amount  = (float)$amount;
            
         $userExist  = User::where('id',$userId)->count();
         $kioskExist = DeviceInfo::where('id',$kioskId)->where('charge',$amount)->count();
         if($kioskExist && $userExist){
            if(is_float($amount)){
               $userInfo = User::select('email')->where('id',$userId)->first();

                $dataArr = array();
                $dataArr = [
                	'name' => $userInfo->email,
                  'amount' => $amount,
                  'qty' => 1,
                  'description'   => $kioskId.'<=>'.$userId,
                  'currency' => "eur",
                  'intent' => 'authorize'
                ];
                $dataArr['payment_method'] = "paypal";
            	$dataArr['returnUrl'] = url('updateKioskSuccess');
               $dataArr['cancelUrl'] = url('updateKioskCancel');
               try {
                  $response = $this->gateway->purchase($dataArr)->send();
                  #echo "<pre>";print_r($response);die;
                  if ($response->isRedirect()) {
                      $response->redirect(); // this will automatically forward the customer
                  } else {
                      // not successful
                      return $response->getMessage();
                  }
               } catch(Exception $e) {
                  return $e->getMessage();
               }
            }else{
               echo json_encode(array('error'=>'Invalid amount'));
            }
         }else{
            echo json_encode(array('error'=>'Invalid kiosk'));
         }
      }else{
         echo json_encode(array('error'=>'Invalid Info provided'));
      }
   }
    
   public function updateKioskSuccess(Request $request){
      $transaction = $this->gateway->completePurchase(array(
         'payer_id'             => $request->input('PayerID'),
         'transactionReference' => $request->input('paymentId'),
      ));
      $response = $transaction->send();
      if ($response->isSuccessful()){
         $arr_body = $response->getData();
         echo "<pre>";print_r($arr_body);die;
         //echo $_GET['paymentId'];die;
            
         $orderArr         = explode('<=>',$arr_body['transactions'][0]['description']);
         $kioskId          = $orderArr[0];
         $userId           = $orderArr[1];
         $transaction_id   = $_REQUEST["token"];
         
         /* update order payment status */
         $deviceExist = DeviceInfo::where('id',$kioskId)->count();
         if($deviceExist){
            $current_date = Defaults::getDate();
            $update_array = array(
               "user_id" =>$userId,"kiosk_id" =>$kiosk_id,
               "transaction_id" => $transaction_id,'payment_type'=>'Paypal'
               ,"payment_date"=>$current_date,"payment_status"=>1);
            
            User_payment::insert($update_array);
            $message = 'Payment done successfully';
            echo json_encode(array('error'=>$message));
         }else{
             $message = 'Invalid order';
             echo json_encode(array('error'=>$message));
         }
      }else{
         $message = trans('messages.Payment is not done yet');
         echo json_encode(array('error'=>$message));
      }
   }       
    
   public function updateKioskCancel(){
      $message = trans('messages.Payment Cancelled');
      echo json_encode(array('error'=>$message));
	}
   /* Paypal payment finish */
    
    
   /* Stripe payment start */
   public function stripe(Request $request,$userId,$kioskId,$amount){
      if(!empty($kioskId) && !empty($amount) && !empty($userId)){
         $kioskId = (int)$kioskId;
         $userId  = (int)$userId;
         $amount  = (float)$amount;

         $userExist  = User::where('id',$userId)->count();
         $kioskExist = DeviceInfo::where('id',$kioskId)->where('charge',$amount)->count();
         if($kioskExist && $userExist){
            $setting_obj   = new Settings_model();
            $settingInfo   = $setting_obj->select('value')->where('attribute','Currency')->first();
            
            if(is_float($amount)){
               $Stripes_obj            = new Stripes();
               $stripe_record          = $Stripes_obj->get()->toArray();
               $data['kd']             = $kioskId;
               $data['ud']             = $userId;
               $data['amt']            = $amount;
               $data['crn']            = $settingInfo->value;
               $data["STRIPE_KEY"]     = $stripe_record[0]["stripe_key"];
               $data["STRIPE_SECRET"]  = $stripe_record[0]["stripe_secret"];
               return view('stripe')->with(array("data"=>$data));
            }else{
               echo json_encode(array('error'=>'Invalid amount'));
            }
         }else{
            echo json_encode(array('error'=>'Invalid Kiosk'));
         }
      }else{
         echo json_encode(array('error'=>'Invalid Info provided'));
      }
   }
    
   public function stripePost(Request $request){
      $kd         = $request->kd;
      $ud         = $request->ud;
      $userExist  = User::where('id',$ud)->count();
      $kioskExist = DeviceInfo::where('id',$kd)->count();
      if($kioskExist && $userExist){
         $kioskInfo  = DeviceInfo::select('charge')->where('id',$kioskId)->first();
         try{
  	         //Stripe\Stripe::setApiKey(env('STRIPE_SECRET'));
  	         $Stripes_obj   = new Stripes();
            $stripe_record = $Stripes_obj->get()->toArray();
            Stripe\Stripe::setApiKey($stripe_record[0]["stripe_secret"]);
         	
            $amt           = $kioskInfo->charge;
	         $description   = 'Power bank usase payment'; 
   	      $charge = Stripe\Charge::create ([
               "amount" => 100 * $amt,
               "currency" => "eur",
               "source" => $request->stripeToken,
               "description" => $description,
               'metadata' => array(
                  'kiosk_id' => $kd,
                  'user_id' => $ud,
               )
            ]);
         	    
   	      /* If payment is success */
   	      $chargeJson = $charge->jsonSerialize();
   	      if($chargeJson['amount_refunded'] == 0 && empty($chargeJson['failure_code']) && $chargeJson['paid'] == 1 && $chargeJson['captured'] == 1){
               
               $kiosk_id               = $chargeJson['metadata']["kiosk_id"];
               $user_id                = $chargeJson['metadata']["user_id"];
               $balance_transaction    = $chargeJson['balance_transaction'];
                    
               /* Update in order table */
               $current_date = Defaults::getDate();
               $update_array = array(
                  "user_id" =>$user_id,"kiosk_id" =>$kiosk_id,
                  "transaction_id" => $balance_transaction,'payment_type'=>'Stripe'
                  ,"payment_date"=>$current_date,"payment_status"=>1);
               
               User_payment::insert($update_array);
               return redirect('orderStripeSuccess');
            }else{
               //echo 'fsf';
               return redirect('orderStripeCancel');
            }    
         }catch(Stripe\Exception\CardException $e) {
       		$message =  $e->getError()->message;
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
      		return redirect("stripe/".$od.'/'.$amt);
     	   }    
      }else{
         //echo 'invalid';
         return redirect('orderStripeCancel');
      }
   }
    
   public function orderStripeSuccess(){
      echo json_encode(array('error'=>'Payment success'));
   }
    
   public function orderStripeCancel(){
      echo json_encode(array('error'=>trans('messages.went_wrong')));
   }
}