<?php
namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DB;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use Validator;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Hash;
use App\Http\Requests\SitesettingValidation;
use App\Http\Requests\PromoValidation;
use App\Mail\DemoEmail;
use App\Paypals;
use App\Stripes;
use App\User;
use App\Adminlogin;
use App\Settings_model;
use App\Promocodes;

class AdminController extends Controller
{
   public function __construct()
   {
    DB::enableQueryLog();
   }

   public function CommonAed(Request $request,$userId,$status,$callback,$tablename){
      try {
         //echo $tablename;die;
         $id = Crypt::decryptString($userId);
         $status = Crypt::decryptString($status);
         $tablename = Crypt::decryptString($tablename);
      } catch (DecryptException $e) {
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         return redirect('admin/dashboard');
      }
      if($status != 0 && $status != 1 && $status != 2 && $status != 3)
      {
        $message = trans('messages.invalid_info');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        return redirect("admin/".$callback);
      }
      #echo $tablename;die;
      $result = DB::table($tablename)->where("id",$id)->count();
      if($result)
      {
         $update_array = array("status" => $status);
         $response = DB::table($tablename)->where("id",$id)->update($update_array);
         if($response == 1)
         {
            if($tablename == 'Users')
            {
               /*$user_obj = new Users();
               $userInfo = $user_obj->select('loginType','userName','email')->where('id',$id)->first();
               $userType = $userInfo['loginType'];*/
                 /*$mailMsg = '';$mailSubject = '';
                 if($status == 1){ //Approve
                    $mailMsg = trans('messages.Your account has been unarroved');
                    $mailSubject = trans('messages.Account Unapproved');
                 }elseif($status == 2){  //Unapprove
                    $mailMsg = trans('messages.Your account has been arroved');
                    $mailSubject = trans('messages.Account Approved');   
                 }
                 $objDemo = new \stdClass();
                 $objDemo->invoice_file = '';
                 $objDemo->sender = 'SwissExpress';
                 $objDemo->receiver = $userInfo['userName'];
                 $objDemo->from = env( 'MAIL_USERNAME' );
                 $objDemo->subject = $mailSubject;
                 $objDemo->message = $mailMsg;
                 $objDemo->view_file = 'emailtemplate.company_account_status';
                 Mail::to($userInfo['email'])->send(new DemoEmail($objDemo)); */
            }
            $messages = trans('messages.Record updated successfully');
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$messages.".</strong></div>");
         }else{
           $messages = trans('messages.went_wrong');
           $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages."</strong></div>");
         }
      }else{
        $messages = trans('messages.This record is not exist');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages.".</strong></div>");
      }
      return redirect("admin/".$callback);
   }

   public function login(Request $request){
		$data['heading'] = trans('messages.Admin Login');
	   return view("admin.login")->with(array("data"=> $data));
   }

   public function LoginSubmit(Request $request){
      
      $validatedData = $request->validate([
         'username' => 'required',
         'password' => 'required'
      ]);

      $admin_obj = new Adminlogin();
      $username = $request->username;
      $password = $request->password;
      
      $adminExist = Adminlogin::where(['username'=>$username])->first();
      if(!empty($adminExist)){

         if(Hash::check($password, $adminExist->password)){
            session(["id" => $adminExist->id,"login_type"=>"Admin"]);
            $message =  trans('messages.login_successfully');
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
               return redirect("admin/dashboard");
         }else{
            $message =  trans('messages.email_pass_not_match');
               $request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
               return redirect("login")->withInput();
         }
      }else{
         $message =  trans('messages.email_pass_not_match');
         $request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
         return redirect("login")->withInput();
      }
   }

    public function dashboard(Request $request){
        $data['heading'] = trans('messages.Admin Dashboard');
        
        /* User counting */
        $user_obj = new User();  
        $data['total_user'] = $user_obj->count();
        $data['new_user'] = $user_obj->where('status',0)->count();
        $data['block_user'] = $user_obj->where('status',3)->count();
      
        return view("admin.dashboard")->with(array("data"=> $data));
    }
   
   public function adminPassReset(){
      $data['heading'] = trans('messages.Admin Reset Password');
      return view("admin.adminPassReset")->with(array("data"=> $data));
   }

   public function adminPassSubmit(Request $request){
      $validatedData = $request->validate([
         'old_pass' => 'required',
         'new_pass' => 'required|required_with:confirm_pass|same:confirm_pass',
         'confirm_pass' => 'required'
      ]);
      
      $admin_obj = new Adminlogin();
      $adminExist = Adminlogin::where(["user_type"=>1,"username"=>"admin"])->first();
      if(!empty($adminExist)){
         if(Hash::check($request->old_pass, $adminExist->password)){
            DB::beginTransaction();
            try{
               $hashedPassword = Hash::make($request->new_pass);
               $user_update = $admin_obj->where('id',$adminExist->id)->update(['password'=>$hashedPassword]);
               DB::commit();
               $message = trans('messages.password_chage_successfully');
               $request->session()->flash("message","<div class='alert  alert-success'><strong>".$message.".</strong></div>");
               return redirect("admin/adminPassReset");
            }catch(\Illuminate\Database\QueryException $ex){
               DB::rollBack();
               $message = $ex->getMessage();
               $request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
               return redirect("admin/adminPassReset");
            }
         }else{
            $message =  trans('messages.invalid detail');
            $request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
            return redirect("admin/adminPassReset");
         }
      }else{
         $message =  trans('messages.invalid detail');
         $request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
         return redirect("admin/adminPassReset");
      }
   }

   public function allsubadmin(Request $request){
        $data['heading'] = trans('messages.List Subadmin');
        $adminlogin_obj = new Adminlogin();
        $query = $adminlogin_obj->where('user_type',2);
      
        if($request->has('searchsubmit') && !empty($request->name))
        {
            $name = $request->name;
            $query->where('username','like', '%' . $name . '%');
        }

        if($request->has('searchsubmit') && !empty($request->profile_status))
        {
            $profile_status = ($request->profile_status == 2) ? 0 : 1;
            $query->where('status',$profile_status);
        }
        $allsubadmin = $query->paginate(10);
        return view("admin.allsubadmin")->with(array("data"=> $data,"allsubadmin"=>$allsubadmin));
   } 

   public function addsubadmin(){
        $data['heading'] = trans('messages.Add Subadmin');
        return view("admin.addsubadmin")->with(array("data"=> $data));
   }

   public function subadminSubmit(Request $request){
        $validatedData = $request->validate([
            'username' => 'required|unique:adminlogin',
            'password' => 'required'
        ]);
        
        $password = Hash::make($request->password);
        
        $insert = array('username'=>$request->username,'password'=>$password,'user_type'=>2);
        $adminlogin_obj = new Adminlogin($insert);
        $result = $adminlogin_obj->save();
        if($result){
            $message = trans('messages.subadmin_add');
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
            return redirect('admin/allsubadmin');
        }else{
            $message = trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect('admin/addsubadmin');
        }
   }
    
   public function editsubadmin(Request $request,$id){
        $id = Crypt::decryptString($id);
        $data['heading'] = trans('messages.Edit Subadmin');
        $adminlogin_obj = new Adminlogin();
        $record = $adminlogin_obj->where('user_type',2)->where("id",$id)->get()->toArray();
        $data["record"] = $record;
        return view("admin.editsubadmin")->with(array("data"=> $data));
   }
    
   public function editsubadminSubmit(Request $request){
        $messages = [
            'username.required' => 'Username is required'
        ];
        
        $validatedData = $request->validate([
            'username' => 'required|unique:adminlogin,username,'.$request->id
        ],$messages);

        $insert = array('username'=>$request->username);
        $adminlogin_obj = new Adminlogin();
        $result = $adminlogin_obj->where("id",$request->id)->update($insert);
        if($result){
            $message = trans('messages.subadmin_add');
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
            $message = trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
        return redirect('admin/allsubadmin');
   }

   public function sendEmailNotification(Request $request,$names){
      if($names == 'users'){
         $table = "users";
         $result = DB::table($table)->where("status",2)->orderBy("id","DESC")->get()->toArray();
            
         $data["heading"] = trans("messages.Email")." ".trans("messages.Notification");
         $data["record"] = $result;
         $data["names"] = $names;
         return view("admin.sendEmailNotification")->with(array("data"=>$data));
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
         return redirect("admin/dashboard");   
      }
   }

   public function sendEmailNotificationSubmit(Request $request){
      $names = $request->names;
      $validatedData = $request->validate([
         'users'=>'required',
         'message'=>'required',
      ]);
      $users = $request->users;
      $message = $request->message;
        
      if($names == 'users'){
         for($x=0; $x<count($users); $x++){
             $id = $users[$x];
             $driver_record = DB::table($names)->select("email")->where("id",$id)->first();
             if($driver_record){
                 $email = $driver_record->email;
                 if(!empty($email)){
                     /* Send welcome mail at registered mail id*/
                     $objDemo = new \stdClass();
                     $objDemo->sender = 'Power-bank';
                     $objDemo->invoice_file = '';
                     $objDemo->receiver = '';
                     $objDemo->from = env( 'MAIL_USERNAME' );
                     $objDemo->subject = "Notification";
                     $objDemo->message = $message;
                     $objDemo->view_file = 'emailtemplate.email_notification';
                     //Mail::to($email)->send(new DemoEmail($objDemo)); 
                 }
             }
         }
         $message =  trans('messages.Message send successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
         return redirect("admin/sendEmailNotification".'/'.$names);   
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
         return redirect("admin/sendEmailNotification".'/'.$names);   
      }
   }

   public function paymentSetting(Request $request){
      $data["heading"] = trans("messages.paymentSetting");
      $Stripes_obj = new Stripes();
      $data["record"] = $Stripes_obj->select("*")->get()->toArray();
      $Paypals_obj = new Paypals();
      $data["paypal_record"] = $Paypals_obj->select("*")->get()->toArray();
      #print_r($data["record"]);die;
      return view("admin.paymentSetting")->with(array("data"=>$data));
   }

   public function stripeSettingSubmit(Request $request){
      $user_id = $request->id;
      $validatedData = $request->validate([
       'stripe_key'=>'required',
       'stripe_secret'=>'required',
      ]);
      #echo "<pre>";print_r($request->all());
      $stripe_key = $request->stripe_key;
      $stripe_secret    = $request->stripe_secret;
      
      $insert_data = array(
        "stripe_key" => $stripe_key,
        "stripe_secret" => $stripe_secret
      );
      #print_r($insert_data);die;
      #DB::enableQueryLog();
      $Stripes_obj = new Stripes();
      $query_response = $Stripes_obj->where("id",$user_id)->update($insert_data);
        //$gett = DB::getQueryLog();
        #print_r($gett);die;
       # echo "hello";die;
      if(!empty($query_response))
      {
         $message =  trans('messages.Record updated successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
      }
      return redirect("admin/paymentSetting");   
   }

   public function paypalSettingSubmit(Request $request){
      $user_id = $request->id;
      $validatedData = $request->validate([
         'api_username'=>'required',
         //'api_password'=>'required',
         'api_secret'=>'required',
      ]);
      #echo "<pre>";print_r($request->all());
      $mode = $request->mode;
      $api_username = $request->api_username;
      //$api_password    = $request->api_password;
      $api_secret    = $request->api_secret;
    
      $insert_data = array(
         "mode" => $mode,
         "api_username" => $api_username,
         //"api_password" => $api_password,
         "api_secret" => $api_secret,
      );
      #print_r($insert_data);die;
      #DB::enableQueryLog();
      $Paypals_obj = new Paypals();
      $query_response = $Paypals_obj->where("id",$user_id)->update($insert_data);
        //$gett = DB::getQueryLog();
        #print_r($gett);die;
       # echo "hello";die;
      if(!empty($query_response))
      {
         $message =  trans('messages.Record updated successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
      }
      return redirect("admin/paymentSetting");   
   }

   public function siteSetting(){ 
      $data['heading'] = trans('messages.Site Setting');
      $setting_obj = new Settings_model();
      $record = $setting_obj->select('*')->get()->toArray();
      return view("admin.siteSetting")->with(array("data"=> $data,"setting"=>$record));
   }

    public function siteSettingSubmit(SitesettingValidation $request){
      $setting_obj = new Settings_model();
      $setting_obj->where('attribute','tax')->update(array('value'=>$request->tax));
      $setting_obj->where('attribute','support_email')->update(array('value'=>$request->support_email));
      $setting_obj->where('attribute','support_contact')->update(array('value'=>$request->support_contact));
      $setting_obj->where('attribute','default_search_radius')->update(array('value'=>$request->default_search_radius));
      $setting_obj->where('attribute','Currency')->update(array('value'=>$request->Currency));
      $setting_obj->where('attribute','default_battery_keeping_days')->update(array('value'=>$request->default_battery_keeping_days));
      $setting_obj->where('attribute','default_minutes_to_start_charge')->update(array('value'=>$request->default_minutes_to_start_charge));
      $setting_obj->where('attribute','per_hour_charge')->update(array('value'=>$request->per_hour_charge));
      $setting_obj->where('attribute','deposit_amount')->update(array('value'=>$request->deposit_amount));
      $setting_obj->where('attribute','per_half_hour_charge')->update(array('value'=>$request->per_half_hour_charge));
      $setting_obj->where('attribute','per_day_charge')->update(array('value'=>$request->per_day_charge));

      if($request->hasFile("site_logo") && $_FILES["site_logo"]["size"] > 0){
         $logo = $request->file('site_logo');
         $file_name = 'logo'.'.'.$logo->getClientOriginalExtension();
         $destinationPath = public_path('images');
         $logo->move($destinationPath, $file_name);

         $setting_obj->where('id',3)->update(array('value'=>$file_name));
      }
      
      $message =  trans('messages.setting_updated');
      $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
      return redirect('admin/siteSetting');
   }

   public function addCoupon(){
      $data['heading'] = trans('messages.Create Coupon');
      $table = "users";
      $result = DB::table($table)->select('id','fullname')->where("status",2)->orderBy("id","DESC")->get()->toArray();
      $data["record"] = $result;
      return view("admin.addCoupon")->with(array("data"=> $data));
   }

   public function addCouponSubmit(PromoValidation $request){
      if(!empty($request->user)){
         try{
            #echo "<pre>";print_r($request->all());
            $insert_data = array(
               "user" => implode(',', $request->user),
               "title" => $request->title,
               "description" => $request->description,
               "code_name" => $request->code_name,
               "expiry_date" => date("Y-m-d",strtotime($request->expiry_date)),
               "quantity" => $request->quantity,
               "promo_type" => $request->promo_type,
               "discount_type" => $request->discount_type,
               "discounted_value" => $request->discounted_value
            );
            $Promocodes_obj = new Promocodes($insert_data);
            $response = $Promocodes_obj->save();
            if($response == 1)
            {
                $message =  trans('messages.added_successfully');
                $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
                return redirect("admin/listCoupon");
            }else{
                $message =  trans('messages.went_wrong');
                $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
               return redirect("admin/addCoupon");
            }
         }catch(DecryptException $e){
            $message = trans('messages.invalid_info');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect("admin/addCoupon");
         }
      }else{
         $message =  trans('messages.select User');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         return redirect("admin/addCoupon");
      }
      
   }
    
   public function listCoupon(Request $request){
      $data["heading"] = trans("messages.listCoupon");
      $Promocodes_obj = new Promocodes();
      $record = $Promocodes_obj->select("*")
         ->orderBy("id","desc")->paginate(10);
      $data["record"] = $record;
      return view("admin.listCoupon")->with(array("data"=>$data));
   }

   public function logout(Request $request){
      $request->session()->flush();
       return redirect ("admin");
   }
}



