<?php
namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DB;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use Validator;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Hash;
use App\Mail\DemoEmail;
use App\DeviceInfo;
use App\Device_battery;

class BatteryController extends Controller
{
	public function __construct(){
 	   DB::enableQueryLog();
	}

	public function listBatteries(Request $request){
		$data['heading'] = trans('messages.List Batteries');
		
		$data['deviceInfo'] = DeviceInfo::select(['id','device_id'])->get()->toArray();
		$query = Device_battery::select('*');
		
		if(($request->has('searchsubmit') || $request->has('exportsubmit')) && !empty($request->deviceId))
        {
            $deviceId = (int)$request->deviceId;
            $query->where('device_id', $deviceId);
        }
		
		if(($request->has('searchsubmit') || $request->has('exportsubmit')) && !empty($request->status))
        {
            $status = $request->status;
            if($status == '2'){
                $status = 0;
            }
           
            $query->where('battery_status', "$status");
        }
		
		$data['batteryList'] = $query->paginate(10)->appends(request()->query());
		return view('admin.batteryList')->with(array("data"=> $data));
	}
}
