<?php
namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Adminlogin;
use DB;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use App\Users;
use App\Setting;
use App\Faq;
use App\WebFaq;
use App\UserFaq;
use App\DriverFaq;
use App\Http\Libraries\firebase\PushMessageCustom;
use Validator;
use Illuminate\Support\Facades\Mail;
use App\Mail\DemoEmail;

class FaqController extends Controller
{
  public function __construct()
  {
      DB::enableQueryLog();
  }

   public function addfaq(Request $request)
   {  
      $data['heading'] = trans('messages.Add Faq');
      return view("admin.addFaq")->with(array("data"=> $data));
   }

   public function addFaqSubmit(Request $request)
   {
  	   $validatedData = $request->validate([
         'question' => 'required',
         'answer' => 'required',
         'type'   => 'required'
      ]);
      $insert = array(
         'question'=>$request->question,
         'answer'=>$request->answer,
      );

      $type = 0;
      if(!empty($request->type)){
         $type = (int)$request->type;
         if($type === 1111){
            $type = 0;
         }
      }
      $insert['type'] = $type;
      $faq_obj = new Faq($insert);
      $result = $faq_obj->save();
      if($result == 1)
      {
         $message = trans('messages.Record added successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
         $message = trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect('admin/addfaq');
   }

	public function listFaq(Request $request)
	{
   	$data['heading'] = trans('messages.List Faq');
     	$faq_obj = new Faq();
   	$record = $faq_obj->paginate(10);
   	$data['record'] = $record;
   	return view("admin.listFaq")->with(array("data"=> $data));
	}

	public function editFaq(Request $request,$id)
	{
		$id = Crypt::decryptString($id);
   	$data['heading'] = trans('messages.Edit Faq');
   	$faq_obj = new Faq();
   	$record = $faq_obj->where("id",$id)->get()->toArray();
   	$data["record"] = $record[0];
   	return view("admin.editFaq")->with(array("data"=> $data));
   }

  	public function editFaqSubmit(Request $request)
  	{
  		$validatedData = $request->validate([
         'question' => 'required',
         'answer' => 'required',
         'type'   => 'required'
      ]);
      $insert = array(
        'question'=>$request->question,
        'answer'=>$request->answer,
      );

      $type = 0;
      if(!empty($request->type)){
         $type = (int)$request->type;
         if($type === 1111){
            $type = 0;
         }
      }
      $insert['type'] = $type;
      
      $faq_obj = new Faq();
      $result = $faq_obj->where("id",$request->id)->update($insert);
      if($result == 1)
      {
         $message = trans('messages.Record updated successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
         $message = trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect('admin/listFaq');
  	}
  	public function deleteFaq(Request $request , $id)
  	{
  		$faq_obj = new Faq();
  		$result = $faq_obj->where("id",$id)->delete();
  		if($result == 1)
   	{
      	$message = trans('messages.Record deleted successfully');
      	$request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
   	}else{
      	$message = trans('messages.went_wrong');
      	$request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
   	}
   	return redirect('admin/listFaq');
  	}

}