<?php
namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DB;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use Validator;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Hash;
use App\Mail\DemoEmail;
use App\DeviceInfo;

class KioskController extends Controller
{
	public function __construct(){
 	   DB::enableQueryLog();
	}

	public function kioskList(){
		$data['heading'] = trans('messages.List Kiosk');
		$data['kioskList'] = DeviceInfo::paginate(10)->appends(request()->query());
		return view('admin.kioskList')->with(array("data"=> $data));
	}

	public function updateKioskInfo(Request $request,$id){
		try{
       	$kiosk_id = Crypt::decryptString($id);
       	$device_record = DeviceInfo::where("id",$kiosk_id)->first();
       	if(!empty($device_record))
       	{
         	$data["record"] = $device_record;
         	$data["heading"] = trans("messages.updateKioskInfo");
         	return view("admin.updateKioskInfo")->with(array("data"=>$data));
       	}else{
            $message = trans('messages.invalid_info');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect('admin/kioskList');
       	}
  	   }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         return redirect('admin/kioskList');
      }
	}

	public function kioskSubmit(Request $request){
		$validatedData = $request->validate([
      	'location_name'	 =>'required',
       	'contact_number' => 'required',
       	'opening_time'	 => 'required',
       	'closing_time'   => 'required',
       	'image'   		=> 'mimes:jpeg,jpg,png,gif',
      ]);

      if($request->hasFile("image") && $_FILES["image"]["size"]>0){
         $image = $request->file('image');
         $random = substr(md5(mt_rand()), 0, 4);
         $file_name = $input['imagename'] = time().$random.'user'.'.'.$image->getClientOriginalExtension();
         $destinationPath = public_path('/upload/kioskProfile');
         $image->move($destinationPath, $input['imagename']);
         if(!empty($request->old_image))
         {
            $old_image = $request->old_image;
            $file_pointer = $destinationPath.'/'.$old_image;
            if (file_exists($file_pointer))
            {
               unlink($destinationPath.'/'.$old_image);
            }
         }
      }else{
         if(!empty($request->old_image))
         {
             $file_name = $request->old_image;
         }else{
             $file_name = NULL;
         }
      }

      $array_data = array(
	    	"location_name" => $request->location_name,
       	"contact_number" => $request->contact_number,
       	"opening_time" => $request->opening_time,
       	"closing_time" => $request->closing_time,
         "image" => $file_name,
      );
      $kiosk_id = $request->id;

      DB::beginTransaction();

      try{
			DeviceInfo::where("id",$kiosk_id)->update($array_data);
         $message =  trans('messages.Record updated successfully');
   	   $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
	      	
      }catch(\Illuminate\Database\QueryException $ex){
         $message =  $ex->getMessage();
         DB::rollBack();
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
   	}
   	DB::commit();
      return redirect("admin/kioskList");
	}
}
