<?php
namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DB;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use Validator;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Hash;
use App\Mail\DemoEmail;
use App\DeviceInfo;
use App\Device_battery;
use App\DeviceOrders;

class OrderController extends Controller
{
	public function __construct(){
 	   DB::enableQueryLog();
	}

	public function allRental(Request $request){
		$data['heading'] = trans('messages.All Rentals');
		
		$data['deviceInfo'] = DeviceInfo::select(['id','device_id'])->get()->toArray();
		$query = DeviceOrders::select('*');
		
		if(($request->has('searchsubmit') || $request->has('exportsubmit')) && !empty($request->deviceId))
        {
            $deviceId = (int)$request->deviceId;
            $query->where('device_id', $deviceId);
        }
		
		$data['orderList'] = $query->paginate(10)->appends(request()->query());
		return view('admin.allRental')->with(array("data"=> $data));
	}
	
	public function currentRental(Request $request){
	    $data['heading'] = trans('messages.Ongoing Rentals');
	    $query = DeviceOrders::select('*');
	    $data['orderList'] = $query->paginate(10)->appends(request()->query());
		return view('admin.currentRental')->with(array("data"=> $data));
	}
	
	public function pastRental(Request $request){
	    $data['heading'] = trans('messages.Completed Rentals');
	    $query = DeviceOrders::select('*');
	    $data['orderList'] = $query->paginate(10)->appends(request()->query());
		return view('admin.pastRental')->with(array("data"=> $data));
	}
}
