<?php

//http://localhost/power-bank/stripe/43434/4343/55.55 ==> Stripe payment
//http://localhost/power-bank/kiosk/payment/43434/4343/55.55 ==> Paypal payment

namespace App\Http\Controllers\api;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
//namespace Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Response;
use App\Http\Service\DataService;
use App\Http\Utility\Common;
use App\Http\Utility\Defaults;
use Illuminate\Database\QueryException;
use Validator;
use DB;
use App\User;
use App\Settings_model;
use App\DeviceInfo;
use App\Device_battery;
use App\Kiosk_rating;
use App\DeviceOrders;
use DateTime;

class Usercontroller extends Controller
{
    public function __construct()
	{
		DB::enableQueryLog();
		//$this->middleware('auth:api');
		//$this->middleware('auth.basic'); 
	}

	public function userRegistration(Request $request){
		$response   = new Response();
    	$rules      = [
         'username' => 'required|unique:users,fullname',
			'email'       => 'required|email|unique:users',
			'password'    => 'required|min:6',
        	'contact_no' => 'required',
        	'address'   =>  'required'
 		];

    	$validator  = Validator::make($request->all(), $rules);
    	if ($validator->fails()) { 
        	$data                   = $validator->messages();
        	$response->error        = Common::error_true;
        	$response->errorMessage = $data->first();
    	}else {
         $data  = new DataService();
            
 	      DB::beginTransaction();
        	try{
     	      if(empty($request->latitude) || empty($request->longitude)){
               $data->error = Common::error_true;
               $data->errorMessage = trans('messages.google_address_error');
            }else{
               $username       = $request->username;
               $email          = $request->email;
               $hashedPassword = Hash::make($request->password);
               $contact_no     = $request->contact_no;
               $user_status    = 2;
                
               $insert_data = array("fullname" => $username,"email" => $email,"password" => $hashedPassword,
    					"mobNumber" => $contact_no,"status" => $user_status,"add_latitude" => $request->latitude,
                  "add_longitude" => $request->longitude,'address' => $request->address
    		    	);
    
               $user = new User($insert_data);
    		    	$user->save();
    		    	
    		    	//$user_id = $user->id; 
    		    	/***********/
    		    	DB::commit();
       	       /* Send welcome mail on registered mail id*/
               $objDemo = new \stdClass();
               $objDemo->invoice_file = '';
               $objDemo->sender = 'Power-Bank';
               $objDemo->receiver = trans('messages.Hello').' '.$username;
               $objDemo->from = env( 'MAIL_USERNAME' );
               $objDemo->subject = trans('messages.Test');
               $objDemo->message1 = "Félicitations !";
               $objDemo->view_file = 'emailtemplate.welcome_mail';
               //Mail::to($email)->send(new DemoEmail($objDemo)); 
               /**************/
                	
             	$data->error         = Common::error_false;
               $data->errorMessage  = trans('messages.sucess');
            }
        	}catch(\Illuminate\Database\QueryException $ex){
         	$data->errorMessage  =  $ex->getMessage();
            DB::rollBack();
            $data->error   = Common::error_true;
        	}
        	$response = $data;
    	}
      $responsedata = Defaults::encode($response);
    	return $responsedata;
	}

	public function userLogin(Request $request){
		$response = new Response();
     	$rules   = ['email'   => 'required|email',
			'password' =>'required',
			'deviceToken'=>'required'];
     	$validator  = Validator::make($request->all(), $rules);
     	if ($validator->fails()) {
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
     	} else {
         $data   = new DataService();
         $email          = $request->email;
         $password       = $request->password;
         $deviceToken    = $request->deviceToken;
         
         if (Auth::attempt(['email' =>$email, 'password' =>$password])) { 
     	 	$authenticated_user = Auth::user();
             $user = User::find($authenticated_user->id);
             if($authenticated_user->status === 2){
                 $user_obj = new User();
   	            $user_obj->where('id',$authenticated_user->id)->update(['deviceToken'=>$deviceToken]);
   	            $profile = '';
                 if($authenticated_user->image){
                    $profile = url('public/upload/usersprofile/'.$authenticated_user->image);
                 }
   	            $data->error = Common::error_false;
                 $data->errorMessage = trans('messages.isLogin');
                 $data->usersDetails  = $authenticated_user;
                 $data->usersDetails->image = $profile;
                 $data->token  = $authenticated_user->createToken('MyApp')->accessToken;
             }else{
                 $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_inactive');   
             }
         }else{
   			$data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.login');
			}
         $response = $data;
      }
     	$responsedata = Defaults::encode($response);
     	return $responsedata;
	}

	public function userForgotPassword(Request $request){
        $Users_obj = new User;
        $response   = new Response();
        $rules = [
            'email' => 'required|email'
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()){ 
            #print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
        }else{
            $data   = new DataService();
            DB::beginTransaction();
            try{
                $email = $request->email;
                $record = $Users_obj->select("fullname","id","email")->where("email",$email)->get()->toArray();
                if(count($record)>0){
                    $new_password = mt_rand(100000, 999999);
                    $new_password_md = Hash::make($new_password);
                    $Users_obj->where("email",$email)->update(["password"=>$new_password_md]);

                    /* Send password on mail at registered mail id*/
                    $objDemo = new \stdClass();
                    $objDemo->sender = 'Digital-Menu';
                    $objDemo->invoice_file = '';
                    $objDemo->receiver = $record[0]["fullname"];
                    $objDemo->password = $new_password;
                    $objDemo->from = env( 'MAIL_USERNAME' );
                    $objDemo->subject = trans('messages.fprgotPassword');
                    //$objDemo->message = $request->message;
                    $objDemo->message = trans('messages.A new password has been send on your registered mail id');
                    $objDemo->view_file = 'emailtemplate.user_forget_password';
                       #print_r($objDemo);die; 
                    //Mail::to($request->email)->send(new DemoEmail($objDemo));
                    /**************/
            
                    $data->error         = Common::error_false;
                    $data->errorMessage  = trans('messages.sucess');
                    #$data->record         = $record[0];
                }else{
                    $data->error        = Common::error_true;
                    $data->errorMessage = trans('messages.no_record');
                }
            }catch(QueryException $ex){
              $jsonresp=$ex->getMessage();
              DB::rollBack();
              $data->error   = $jsonresp;
            }
            $response = $data;
        }
        DB::commit();
        $responsedata = Defaults::encode($response);
        return $responsedata;
   }

    public function myProfile(Request $request){
        $data   = new DataService();
        $userId       = Auth::guard('api')->user()->id;
        //echo $userId;
        //$user = User::find($userId); 
        $data->error   = Common::error_false;
        $data->errorMessage   = trans('messages.sucess');
        $data->user           = User::select(['id','fullname','email','mobNumber','address','image'])->where('id',$userId)->first();
        $data->profileUrl = url('public/upload/usersprofile/');
        $response = $data;
        $responsedata = Defaults::encode($response);
        return $responsedata;
   }

    public function updateProfile(Request $request){
      $userId       = Auth::guard('api')->user()->id;
      $response = new Response();
      $rules   = [
         'username' => 'required|unique:users,fullname,'.$userId,
         'email'       => 'required|email|unique:users,email,'.$userId,
         'contact_no' => 'required',
         'address'   =>  'required'
      ];
      $validator  = Validator::make($request->all(), $rules);
      if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
      } else {
         $data       = new DataService();
         DB::beginTransaction();
         try{
            if(empty($request->latitude) || empty($request->longitude)){
               $data->error = Common::error_true;
               $data->errorMessage = trans('messages.google_address_error');
            }else{
               $username       = $request->username;
               $email          = $request->email;
               $contact_no     = $request->contact_no;
               $latitude       = $request->latitude;
               $longitude      = $request->longitude;
               $address        = $request->address;
               $profile_pic    = '';

               $userInfo = User::select('image')->where('id',$userId)->first();
               $old_image = $userInfo->image;

               if($request->hasFile('image') && $_FILES['image']['size'] > 0){
                  $image = $request->file('image');
                  //echo "<pre>";print_r($image);
                  $random = substr(md5(mt_rand()), 0, 4);
                  $profile_pic = $input['imagename'] = time().$random.'driver'.'.'.$image->getClientOriginalExtension();
                  $destinationPath = public_path('/upload/usersprofile');
                  $image->move($destinationPath, $input['imagename']);
                  //echo $input['imagename']."form submit";

                  if(!empty($old_image))
                  {
                      $destinationPath = public_path('/upload/usersprofile');
                      $file_pointer = $destinationPath.'/'.$old_image;
                      if (file_exists($file_pointer))
                      {
                          unlink($destinationPath.'/'.$old_image);
                      }
                  }
               }

               $array_data = array(
                  "fullname" => $username,
                  "email" => $email,
                  "mobNumber" => $contact_no,
                  "address" => $address,
                  "add_latitude" => $latitude,
                  "add_longitude" => $longitude,
               );
               if(!empty($profile_pic)){
                  $array_data["image"] = $profile_pic;
               }
                    
               $user_obj = new User();
               $query_response = $user_obj->where("id",$userId)->update($array_data);

               if($query_response == 1){
                  $user_record = $user_obj->select(['id','fullname','email','mobNumber','address','image'])->where('id',$userId)->first();
                  $data->error = Common::error_false;
                  $data->errorMessage = trans('messages.sucess');
                  $data->usersDetails = $user_record;
               }else{
                  $data->error         = Common::error_true;
                  $data->errorMessage  = trans('messages.query');
               }
            }
         }catch(\Illuminate\Database\QueryException $ex){
             $data->errorMessage  =  $ex->getMessage();
             DB::rollBack();
             $data->error   = Common::error_true;
         }
         DB::commit();
         $response = $data;
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
   }

    public function updateAddress(Request $request){
      $userId       = Auth::guard('api')->user()->id;
      $response = new Response();
      $rules   = [
         'address'   =>  'required'
      ];
      $validator  = Validator::make($request->all(), $rules);
      if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
      } else {
         $data       = new DataService();
         DB::beginTransaction();
         try{
            if(empty($request->latitude) || empty($request->longitude)){
               $data->error = Common::error_true;
               $data->errorMessage = trans('messages.google_address_error');
            }else{
               $latitude       = $request->latitude;
               $longitude      = $request->longitude;
               $address        = $request->address;
               
               $array_data = array(
                  "address" => $address,
                  "add_latitude" => $latitude,
                  "add_longitude" => $longitude
               );
               $query_response = User::where("id",$userId)->update($array_data);

               if($query_response == 1){
                  $data->error = Common::error_false;
                  $data->errorMessage = trans('messages.sucess');
               }else{
                  $data->error         = Common::error_true;
                  $data->errorMessage  = trans('messages.query');
               }
            }
         }catch(\Illuminate\Database\QueryException $ex){
             $data->errorMessage  =  $ex->getMessage();
             DB::rollBack();
             $data->error   = Common::error_true;
         }
         DB::commit();
         //DB::getQueryLog();
         $response = $data;
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
   }

    public function nearByKiosk(Request $request){
      $response   = new Response();
      $user_id    = Auth::guard('api')->user()->id;
      $data       = new DataService();
      DB::beginTransaction();
      try{
         $device_obj    = new DeviceInfo();
         $setting_obj   = new Settings_model();
         $userObj       = new User();
            
         /* Search for near by Kiosk */
         //$distance = 100;
         $radiusInfo    = $setting_obj->select('value')->where('attribute','default_search_radius')->first();
         $currencyInfo  = $setting_obj->select('value')->where('attribute','Currency')->first();
         $search_radius = 0;
         if(!empty($radiusInfo->value)){
            $search_radius = $radiusInfo->value;
         }
            
         $userLoc    = $userObj->select(['add_latitude','add_longitude'])->where('id',$user_id)->first();
         $addLat     = $userLoc->add_latitude;
         $addLong    = $userLoc->add_longitude;
            
         $query1 = $device_obj->select("device_info.id","device_info.device_status","device_info.device_status",
            "device_info.available_for_rental","device_info.empty_for_return",
            "device_info.device_type","device_info.device_address",
            "device_info.location_name","device_info.image","device_info.device_lat","device_info.device_long"
         );
            
         if(!empty($addLat) && !empty($addLong)){
            $haversine = "(6371 * acos(cos(radians($addLat)) 
               * cos(radians(device_info.device_lat)) 
               * cos(radians(device_info.device_long) 
               - radians($addLong)) 
               + sin(radians($addLat)) 
               * sin(radians(device_info.device_lat))))";
                         
            $query1->selectRaw("{$haversine} AS distance");
            $query1->havingRaw('CEILING(distance) <= '.$search_radius);
         }
         $record = $query1->get()->toArray();
         //dd(DB::getQueryLog());
         /******************/
            
         if(count($record) > 0){
            $x = 0; 
            foreach ($record as $key => $value){
               //$record[$x]["opening_time"]   = str_replace(':','h',$value['opening_time']);
               //$record[$x]["closing_time"]   = str_replace(':','h',$value['closing_time']);
               $record[$x]["distance"]       = ceil($value['distance']);
               $x++;
            }
            $data->error = Common::error_false;
            $data->errorMessage = trans('messages.sucess');
            $data->imageUrl = url('public/upload/kioskProfile').'/';
            $data->currency = $currencyInfo->value;
            $data->record = $record;
         }else{
            $data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.no_record');
         }
      }catch(QueryException $ex){
         $data->errorMessage  = $ex->getMessage();
         $data->error         = Common::error_true;
         DB::rollBack();
      }
      DB::commit();
      $response = $data;
      
      $responsedata = Defaults::encode($response);
      return $responsedata;   
   }

    public function kioskDetail(Request $request){
      $response   = new Response();
      $rules   = ['kioskId'   => 'required|numeric'];
      $validator  = Validator::make($request->all(), $rules);
      if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
      } else {
         $user_id    = Auth::guard('api')->user()->id;
         $data       = new DataService();
         DB::beginTransaction();  
         try{
            $device_obj    = new DeviceInfo();
            $setting_obj   = new Settings_model();
            $userObj       = new User();
            $kioskId       = $request->kioskId;

            $userLoc    = $userObj->select(['add_latitude','add_longitude'])->where('id',$user_id)->first();
            $addLat     = $userLoc->add_latitude;
            $addLong    = $userLoc->add_longitude;
               
            $currencyInfo  = $setting_obj->select('value')->where('attribute','Currency')->first();
            $query = $device_obj->select("device_status",
               "available_for_rental","empty_for_return",
               "device_type","device_address","location_name","contact_number",
               "opening_time","closing_time","image"
            );
            $query->where('id',$kioskId);
            if(!empty($addLat) && !empty($addLong)){
               $haversine = "(6371 * acos(cos(radians($addLat)) 
                  * cos(radians(device_lat)) 
                  * cos(radians(device_long) 
                  - radians($addLong)) 
                  + sin(radians($addLat)) 
                  * sin(radians(device_lat))))";
                            
               $query->selectRaw("{$haversine} AS distance");
            }
            
            $record = $query->first();
            //dd(DB::getQueryLog());
            /******************/
               
            if(!empty($record)){
               $record->opening_time   = str_replace(':','h',$record->opening_time);
               $record->closing_time   = str_replace(':','h',$record->closing_time);
               $record->distance       = ceil($record->distance);
               $record->profile_pic    = url('public/upload/kioskProfile').'/';
               if(!empty($record->image)){
                  $record->profile_pic = url('public/upload/kioskProfile').'/'.$record->image;
               }
               
               $data                = $record;
               $data->error         = Common::error_false;
               $data->errorMessage  = trans('messages.sucess');
               $data->currency      = $currencyInfo->value;
               
            }else{
               $data->error         = Common::error_true;
               $data->errorMessage  = trans('messages.no_record');
            }
         }catch(QueryException $ex){
            $data->errorMessage     = $ex->getMessage();
            $data->error            = Common::error_true;
            DB::rollBack();
         }
         DB::commit();
         $response = $data;
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;   
   }

    public function viewSingleKioskOnMap(Request $request){
      $response   = new Response();
      $rules   = ['kioskId'   => 'required|numeric'];
      $validator  = Validator::make($request->all(), $rules);
      if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
      } else {
         $user_id    = Auth::guard('api')->user()->id;
         $data       = new DataService();
           
         try{
            $device_obj    = new DeviceInfo();
            $userObj       = new User();
            $kioskId       = $request->kioskId;

            $userLoc    = $userObj->select(['add_latitude','add_longitude'])->where('id',$user_id)->first();
            $addLat     = $userLoc->add_latitude;
            $addLong    = $userLoc->add_longitude;
               
            $query = $device_obj->select("device_status",
               "available_for_rental","empty_for_return","device_address","location_name","contact_number",
               "device_lat","device_long","image"
            );
            $query->where('id',$kioskId);
            if(!empty($addLat) && !empty($addLong)){
               $haversine = "(6371 * acos(cos(radians($addLat)) 
                  * cos(radians(device_lat)) 
                  * cos(radians(device_long) 
                  - radians($addLong)) 
                  + sin(radians($addLat)) 
                  * sin(radians(device_lat))))";
                            
               $query->selectRaw("{$haversine} AS distance");
            }
            
            $record = $query->first();
            //dd(DB::getQueryLog());
            /******************/
               
            if(!empty($record)){
               $record->distance       = ceil($record->distance);
               $record->profile_pic    = url('public/upload/kioskProfile').'/';
               if(!empty($record->image)){
                  $record->profile_pic = url('public/upload/kioskProfile').'/'.$record->image;
               }
               
               $data                = $record;
               $data->userLat       = $userLoc->add_latitude;
               $data->userLong      = $userLoc->add_longitude;
               $data->error         = Common::error_false;
               $data->errorMessage  = trans('messages.sucess');
               
            }else{
               $data->error         = Common::error_true;
               $data->errorMessage  = trans('messages.no_record');
            }
         }catch(QueryException $ex){
            $data->errorMessage     = $ex->getMessage();
            $data->error            = Common::error_true;
            DB::rollBack();
         }
         $response = $data;
      }
      $responsedata = Defaults::encode($response);
      return $responsedata; 
   }

    public function rateKiosk(Request $request){
        $response   = new Response();
        $rules   = ['kioskId'   => 'required|numeric',
            'rating'   => 'required|numeric'
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
        } else {
         $data       = new DataService();
         DB::beginTransaction();
         try{
            $device_obj    = new DeviceInfo();
            $userObj       = new User();
            $kioskId       = $request->kioskId;
            $user_id       = Auth::guard('api')->user()->id;
            $rating        = $request->rating;
 
            $insert        = array('user_id'=>$user_id,'kiosk_id'=>$kioskId,'rating'=>$rating);
            Kiosk_rating::insert($insert);
            //dd(DB::getQueryLog());
            /******************/
            $data->error         = Common::error_false;
            $data->errorMessage  = trans('messages.sucess');
         }catch(QueryException $ex){
            $data->errorMessage     = $ex->getMessage();
            $data->error            = Common::error_true;
            DB::rollBack();
         }
         DB::commit();
         $response = $data;
      }
      $responsedata = Defaults::encode($response);
      return $responsedata; 
   }

    public function supportDesk(){
      $data   = new DataService();

      $setting_obj = new Settings_model();
      $record1 = $setting_obj->where('attribute','support_contact')->first();
      $record2 = $setting_obj->where('attribute','support_email')->first();

      $data->error = Common::error_false;
      $data->errorMessage = trans('messages.sucess');
      $data->support_contact      = $record1->value;
      $data->support_email        = $record2->value;

      $responsedata = Defaults::encode($data);
      return $responsedata;
   }
	
	
	public function loginNotAllowed(){
		$response   = new Response();
		$data   = new DataService();
		
		$data->error   = Common::error_true;
      $data->errorMessage   = 'Invalid User';
        
      $response = $data;
      $responsedata = Defaults::encode($response);
    	return $responsedata;
	}

    public function requestBattery(Request $request){
        $response   = new Response();
        $rules   = ['device_id'   => 'required|numeric'
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
        }else {
            $data       = new DataService();
            DB::beginTransaction();
            try{
                $device_obj     = new DeviceInfo();
                $battery_obj    = new Device_battery();
                $order_obj      = new DeviceOrders();
                $setting_obj    = new Settings_model();
                $device_id      = $request->device_id;
                $user_id        = Auth::guard('api')->user()->id;
                $settingInfo    = $setting_obj->select('value')->where('attribute','deposit_amount')->first(); 
                
                $device_exist = $device_obj->where(['device_id'=>$device_id])->count();
                if($device_exist){
                    $batteryInfo        = $battery_obj->select('battery_id')->where(['device_id'=>$device_id,'battery_status'=>'1'])->first();
                    $batryId            = $batteryInfo->battery_id;
                    $current_timestamp  =  Defaults::getCurrentTimeStamp();
                    
                    /* Save info in orde table when any user request for a battery */
                    $order_id = '';
                    $str_result = '0123456789'.$device_id.time(); 
                    $order_code = substr(str_shuffle($str_result),0, 8); 
                    $order_code_response = $this->check_order_code($order_code);
                    if($order_code_response > 0)
                    {
                        $str_result = '0123456789'.$device_id.time(); 
                        $order_code = substr(str_shuffle($str_result),0, 8); 
                        $order_code_response = $this->check_order_code($order_code);
                    }else{
                        $order_id = $order_code;
                    }
                    $orderInfo = array(
                        'order_id' => $order_id,
                        'user_id' => $user_id,
                        'device_id' => $device_id,
                        'deposit_amount' => $settingInfo->value
                    );
                    $order_obj1 = new DeviceOrders($orderInfo);
                    $order_obj1->save();
                    /************/

                    /* Firsty Server send indication to device that a user requested for battery : 04BatteryLeasing */
                    $iotdata    = array(
                        "T"=>"W","R"=>"B",
                        "D"=>$device_id,"M"=>"Password",
                        "G"=>$order_id,"B"=>$batryId,"N"=>$current_timestamp,
                    );
                    
                    //Send this info to device
                    /****************/
                    
                    /* Now, device will send info in response */
                    $params 				= 	json_decode(file_get_contents('php://input'), TRUE);
            		$indication_from		= 	$params['T'];	//T-from device , W-from server
            		$heartbeat_type 		= 	$params['R'];	//B-Borrow
            		$rental_success 		= 	$params['C'];	//0-rental success, 1-rental error
            		$rental_erorr 		    = 	$params['Q'];	//rental error message
            		$order_number 		    = 	$params['G'];	//Order number that i send to device
            		$device_id 				= 	$params['D'];   //Device id
            		$password				= 	$params['M'];   //Password
            		$bateryId				= 	$params['B'];   //Battery Id
            		$device_type			= 	$params['Y'];	//5=5 port device, 12= 12 port device
            		$batery_list			= 	$params['L'];   //Battery information list
                    /************************/    
                    
                    /* Once rented success update battery list */
                    $insert_batry = 0;
            		for($re = 0; $re < count($batery_list); $re++){
            			$batery_exist = Device_battery::where(['battery_id'=>$batery_list[$re]['B1']])->count();
            			if($batery_exist){
            				Device_battery::where(['battery_id'=>$batery_list[$re]['B1']])->update([
            					'device_id'=>$device_id,'battery_port'=>$batery_list[$re]['B2']
            					,'battery_unit'=>$batery_list[$re]['B3'],
            					'battery_switch'=>$batery_list[$re]['B4'],'battery_logo_bit'=>$batery_list[$re]['B5']
            				]);
            			}else{
            				$insert_batry = 1;
            				$arr[] = array(
            					'device_id'=>$device_id,'battery_id'=>$batery_list[$re]['B1'],
            					'battery_port'=>$batery_list[$re]['B2'],'battery_unit'=>$batery_list[$re]['B3'],
            					'battery_switch'=>$batery_list[$re]['B4'],'battery_logo_bit'=>$batery_list[$re]['B5']
            				);
            				
            			}
            		}
            
            		if($insert_batry){
            			Device_battery::insert($arr);
            		}
                    /**********/
                    
                    if($rental_success){
                        $data->error         = Common::error_true;
                        $data->errorMessage  = $rental_erorr;
                    }else{
                        $rented_time = Defaults::getDate();
                        $battery_obj->where(['battery_id'=>$bateryId])->update(['battery_status'=>'0']);
                        $order_obj->where(['order_id'=>$order_number])->update(['battery_id'=>$bateryId,
                                                                        'rented_time'=>$rented_time,
                                                                        'rental_status'=>'1']);
                        
                        $data->error         = Common::error_false;
                        $data->errorMessage  = trans('messages.sucess');
                    }
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.no_record');
                }
            }catch(QueryException $ex){
                $data->errorMessage     = $ex->getMessage();
                $data->error            = Common::error_true;
                DB::rollBack();
            }
            DB::commit();
            $response = $data;
        }
        $response = $data;
        $responsedata = Defaults::encode($response);
        return $responsedata;
        /**********/
    }
    
    public function returnBattery(Request $request){
        
    }
    
    public function chargeCalculation(){
        $setting_obj    = new Settings_model();
        $settingInfo1    = $setting_obj->select('value')->where('attribute','default_battery_keeping_days')->first(); 
        $settingInfo2    = $setting_obj->select('value')->where('attribute','deposit_amount')->first(); 
        $settingInfo3    = $setting_obj->select('value')->where('attribute','tax')->first(); 
        $settingInfo4    = $setting_obj->select('value')->where('attribute','per_hour_charge')->first(); 
        $settingInfo5    = $setting_obj->select('value')->where('attribute','per_half_hour_charge')->first(); 
        $settingInfo6    = $setting_obj->select('value')->where('attribute','per_day_charge')->first(); 
        
        $today_date = date('Y-m-d H:i:s');
        $rental_date = date('2021-03-01 22:00:00');
        $return_date = '';
        $datetime1 = new DateTime($today_date);
        $datetime2 = new DateTime($rental_date);
        $interval = $datetime1->diff($datetime2);
        
        echo $interval->format('%y years %m months %a days %h hours %i minutes %s seconds');
        echo '<br>';
        
        $days =  $interval->format('%a');
        $hours = $interval->format('%h');
        $minutes = $interval->format('%i');
        
        echo '<br> 1=>default_battery_keeping_days => '.$settingInfo1->value;
        echo '<br> 2=>deposit_amount => '.$settingInfo2->value;
        echo '<br> 3=>tax => '.$settingInfo3->value;
        echo '<br> 4=>per_hour_charge => '.$settingInfo4->value;
        echo '<br> 5=>per_half_hour_charge => '.$settingInfo5->value;
        echo '<br> 6=>per_day_charge => '.$settingInfo6->value;
        
        //echo 'day=>'.$days.'<=Hour=>'.$hours.'<=Minute=>'.$minutes;
        
        $applied_charge = 0;
        if($days > $settingInfo1->value){
            //If rental duration has expired, then your portable power bank is considered purchased.
            //If this happens, a sale fee plus tax of thirty-five euro will be charged to your credit card.
            $taxcahrge = $settingInfo3->value * ($settingInfo2->value/100);
            
            
            $applied_charge = $settingInfo2->value + $taxcahrge;
        }else{ 
            $charge1 = $charge2 = $charge3 = 0;
            if($days > 0){
                $charge1 = $days * $settingInfo6->value;
            }if($hours > 0){
                $charge2 = $hours * $settingInfo4->value;
            }if($minutes > 0){
                if($minutes > 0 && $minutes < 31){
                    $charge3 = $settingInfo5->value;
                }elseif($minutes > 30){
                    $charge3 = 1 * $settingInfo4->value;
                }
            }
            $applied_charge = $charge1 + $charge2 + $charge3;
        }
        
        echo '<br><br>'.'Applied charge => '.$applied_charge;
        
    }
    
    public function check_order_code($str_result){
        $Order_obj = new DeviceOrders();
        $count = $Order_obj->where("order_id",$str_result)->count();
        return $count;
    }
}