@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
   <section class="content">
       <div class="container-fluid">
       <!-- Small boxes (Stat box) -->
         <div class="row">
            <div class="col-md-12">
               {!! session("message") !!}
            </div>   
            <div class="col-md-12">
               <div class="card">
                  <!-- /.card-header -->
                  <div class="card-body">
                     <div class="src-filter">
                        <div class="card card-primary">
                            <div class="card-header">
    			                <h3 class="card-title">{{ __('messages.Filter')}}</h3>
                                <div class="card-tools">
				                    <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
					                    <i class="fas fa-minus"></i>
					                </button>
				              </div>
				            </div>
                            <div class="card-body">
                                {{ Form::open(array("url"=>"admin/listBatteries",'method' => 'get')) }}
					              <div class="row">
					                @if(count($data['deviceInfo']) > 0)
					                <div class="col-md-3">
						                <div class="form-group">
						                    {{Form::label("deviceId",__('messages.Device Id'))}}
		                                    <select class="form-control custom-select" name="deviceId" id="deviceId">
    			                                <option value="">{{ __('messages.Select')}}</option>
    			                                @foreach($data['deviceInfo'] as $value)
    			                                <option value="{{$value['device_id']}}" @php if(isset($_GET["deviceId"])){ if((int)$_GET["deviceId"] == $value['device_id']){ echo "selected"; } }  @endphp >{{ $value['device_id']}}</option>
    			                                @endforeach
			                                </select> 
						                </div>
						            </div>
						            @endif
						            
						            <div class="col-md-3">
						                <div class="form-group">
						                    {{Form::label("status",__('messages.Battery Status'))}}
		                                    <select class="form-control custom-select" name="status" id="status">
    			                                <option value="">{{ __('messages.Select')}}</option>
    			                                <option value="1" @php if(isset($_GET["status"])){ if((int)$_GET["status"] == '1'){ echo "selected"; } }  @endphp >{{ __('messages.Available')}}</option>
    			                                <option value="2" @php if(isset($_GET["status"])){ if((int)$_GET["status"] == '2'){ echo "selected"; } }  @endphp >{{ __('messages.Not Available')}}</option>
    			                            </select> 
						                </div>
						            </div>
						            
						            <div class="col-12">
							            <a href="{{url('admin/listBatteries')}}" class="btn btn-danger">{{ __('messages.Reset') }}</a>
							            {{ Form::submit(__('messages.Search'),['name' => 'searchsubmit', "class"=>"btn btn-warning"]) }}
		                                @if(count($data["batteryList"]) > 0)
		                                {{ Form::submit(__('messages.Export'),['name' => 'exportsubmit', "class"=>"btn btn-success"]) }}
			                            @endif
							        </div>
						        </div>
						        {{ Form::close() }}
				            </div>
                        </div>
                     </div>  
                     <table id="myTable" class="table table-bordered table-striped">
                        <thead>
                            <tr>
                                <th>{{ __('messages.ID')}}</th>
                                <th>{{ __('messages.Device Id')}}</th>
                                <th>{{ __('messages.Battery Id')}}</th>
                                <th>{{ __('messages.Battery Port')}}</th>
                                <th>{{ __('messages.Battery Status')}}</th>
                            </tr>
                        </thead>
                        <tbody>
                           @php $x= 1; @endphp
                           @forelse($data["batteryList"] as $value)
                           @php $id = Crypt::encryptString($value->id); @endphp
                            <tr>
                                <td>{{$x}}</td>
                                <td>{{$value->device_id}}</td>
                                <td>{{$value->battery_id}}</td>
                                <td>{{$value->battery_port}}</td>
                                <td>
                                    @if($value->battery_status === '1')
                                        <span class="bg-success">{{ __('messages.Available')}}</span>
                                    @else
                                        <span class="bg-danger">{{ __('messages.Not Available')}}</span>
                                    @endif
                                </td>
                            </tr>
                           @php $x++; @endphp
                           @empty
                           {{--<p>{{ __('messages.no_record')}}</p>--}}

                           @endforelse     
                        </tbody>
                        <tfoot>
                        <tr>
                            <th>{{ __('messages.ID')}}</th>
                            <th>{{ __('messages.Device Id')}}</th>
                            <th>{{ __('messages.Battery Id')}}</th>
                            <th>{{ __('messages.Battery Port')}}</th>
                            <th>{{ __('messages.Battery Status')}}</th>
                        </tr>
                        </tfoot>
                     </table>
                     @if(!empty($data["batteryList"]))
                     {{$data["batteryList"]->appends(request()->input())->links()}}
                     @endif 
                  </div>
              </div>
         </div>
      </div>
   </section>

@include("admin.template.footer")
<script>
$(function () {
    $("#myTable").DataTable({
        aaSorting : [[0, 'desc']],
        "responsive": true,
        "autoWidth": false,
        "language": {
            "emptyTable": "{{ __('messages.no_record')}}"
        },
        
        "searching": false,   // Search Box will Be Disabled
        "ordering": false,    // Ordering (Sorting on Each Column)will Be Disabled
        "info": true,         // Will show "1 to n of n entries" Text at bottom
        "lengthChange": false // Will Disabled Record number per page
    });
});
</script>