@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
	<section class="content">
	    <div class="container-fluid">
	    <!-- Small boxes (Stat box) -->
	    	<div class="row">
	    		<div class="col-md-12">
      				{!! session("message") !!}
      			</div>	
	    		<div class="col-md-12">
			    	<div class="card">
		              <!-- /.card-header -->
		              <div class="card-body">
		              		<div class="card card-primary">
					            <div class="card-header">
					              <h3 class="card-title">{{$data['heading']}}</h3>

					              <div class="card-tools">
					                <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
					                  <i class="fas fa-minus"></i>
					                </button>
					              </div>
					            </div>
					            <div class="card-body">
					            	 {{ Form::open(array("url"=>"admin/editUserSubmit",'method' => 'post',"files"=>true)) }}
					            	{{Form::hidden("id",$data["record"][0]['id'],["class"=>"form-control"])}}
										
						              <div class="form-group">
						                <label for=" ">{{ __('messages.Fullname')}}</label>
						                {{Form::text("fullname",$data["record"][0]['fullname'],["class"=>"form-control"])}}
						                <div class="error">{{ $errors->first('fullname') }}</div>
						              </div>
						              
						              <div class="form-group">
				                       {{Form::label("status",__('messages.Email'))}}
				                       <input type="text" name="email" value="@php echo $data['record'][0]['email']  @endphp" class="form-control">
				                     	<div class="error">{{ $errors->first('email') }}</div>
				                     </div>
	                     			<div class="form-group">
				                       {{Form::label("status",__('messages.Telephone Number'))}}
				                       <input type="text" name="mobNumber" value="@php echo $data['record'][0]['mobNumber']  @endphp" class="form-control">
				                     <div class="error">{{ $errors->first('mobNumber') }}</div>
				                     </div>
				                     <div class="form-group">
				                        {{Form::label("status",__('messages.Image'))}}
					                       <input type="file" name="image">
					                       @if(!empty($data['record'][0]['image']))
					                       <img src="{{ url('public/upload/usersProfile').'/'.$data['record'][0]['image'] }}" height="80" width="80">
					                       <input type="hidden" name="old_image" value="@php echo $data['record'][0]['image']  @endphp" class="form-control">
					                       @endif
					                       
					                       
					                     <div class="error">{{ $errors->first('image') }}</div>
					                </div>
					                <div class="form-group">
				                       {{Form::label("status",__('messages.address'))}}
				                       {{Form::text("address",$data['record'][0]['address'],["class"=>"form-control","id"=>"searchTextField"])}}
				                     <div class="error">{{ $errors->first('address') }}</div>
				                     {{Form::hidden("latitude",$data['record'][0]['add_latitude'],["class"=>"form-control","id"=>"pick_up_latitude"])}}
				                     {{Form::hidden("longitude",$data['record'][0]['add_longitude'],["class"=>"form-control","id"=>"pick_up_longitude"])}}
				                     </div>

						              	<div class="col-12">
								          <a href="#" class="btn btn-secondary">{{ __('messages.Cancel')}}</a>
								          <input type="submit" value="{{ __('messages.Submit')}}" class="btn btn-success float-right">
								          <span></span>
								        </div>
								    {{Form::close()}}    
					            
					            </div>
					            <!-- /.card-body -->
				          </div>
		              </div>
		              <!-- /.card-body -->
		            </div>
		        </div>
	    	</div>
		</div>
	</section>

@include("admin.template.footer")
<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAQtiGmdJ8a92f4o9DTml0yDPYIFvejybI&libraries=places"></script>

<script type="text/javascript">


function initialize() {
        var input = document.getElementById('searchTextField');
        var autocomplete = new google.maps.places.Autocomplete(input);
        google.maps.event.addListener(autocomplete, 'place_changed', function () {
            var place = autocomplete.getPlace();
            //document.getElementById('city2').value = place.name;
            document.getElementById('pick_up_latitude').value = place.geometry.location.lat();
            document.getElementById('pick_up_longitude').value = place.geometry.location.lng();
            //alert("This function is working!");
            //alert(place.name);
           // alert(place.address_components[0].long_name);

        });
    }
    google.maps.event.addDomListener(window, 'load', initialize); 
</script>