@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
  <section class="content">
      <div class="container-fluid">
      <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-md-12">
              {!! session("message") !!}
            </div>  
          <div class="col-md-12">
            <div class="card">
                  <!-- /.card-header -->
                  <div class="card-body">
                    <table id="myTable" class="table table-bordered table-striped">
                      <thead>
                      
                      <tr>
                        <th>{{ __('messages.ID')}}</th>
                        <th>{{ __('messages.Faq Type')}}</th>
                        <th>{{ __('messages.Question')}}</th>
                        <th>{{ __('messages.Answer')}}</th>
                        <th>{{ __('messages.Action')}}</th>
                      </tr>
                      </thead>
                      <tbody>
                        @php $x= 1; @endphp
                        @forelse($data["record"] as $userValue)
                        @php $id = Crypt::encryptString($userValue->id); @endphp
                        <tr>
                          <td>{{$x}}</td>
                          <td>
                            @if($userValue->type === 1) {{__('messages.User')}}
                            @elseif($userValue->type === 2) {{__('messages.Restaurant')}}
                            @else   {{__('messages.For all')}}
                            @endif

                          </td>
                          <td>{{$userValue->question}}</td>
                          <td>{{$userValue->answer}}</td>
                          <td>

                                <a class="btn btn-info btn-sm" href="{{ url('admin/editFaq').'/'.$id }}">
                                  <i class="fas fa-pencil-alt">
                                  </i>
                                  Edit
                                </a>
                                
                            <a class="btn btn-danger btn-sm" href="{{ url('admin/deleteFaq').'/'.$userValue->id }}">
                              <i class="fas fa-trash">
                              </i>
                              Delete
                          </a>
                          </td>
                          
                        </tr>
                        @php $x++; @endphp
                        @empty
                        <p>{{ __('messages.no_record')}}</p>

                        @endforelse
                      </tbody>
                      <tfoot>
                      
                      <tr>
                        <th>{{ __('messages.Id')}}</th>
                        <th>{{ __('messages.Faq Type')}}</th>
                        <th>{{ __('messages.Category')}}</th>
                        <th>Sub Category Image</th>
                        <th>{{ __('messages.Action')}}</th>
                      </tr>
                      </tfoot>
                    </table>
                    @if(count($data["record"])>0)
                  <div class="pagination-link">{{$data["record"]->links()}}</div>
                  @endif
                  </div>
                  <!-- /.card-body -->
                </div>
            </div>
        </div>
    </div>
  </section>

@include("admin.template.footer")
<script>
$(function () {
    $("#myTable").DataTable({
      "responsive": true,
      "autoWidth": false,
    });
    $('#example2').DataTable({
      "paging": true,
      "lengthChange": false,
      "searching": false,
      "ordering": true,
      "info": true,
      "autoWidth": false,
      "responsive": true,
    });
  });
</script>