@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
	<section class="content">
	    <div class="container-fluid">
	    <!-- Small boxes (Stat box) -->
	    	<div class="row">
	    		<div class="col-md-12">
      				{!! session("message") !!}
      			</div>	
	    		<div class="col-md-12">
			    	<div class="card">
		              <!-- /.card-header -->
		              <div class="card-body">
		              	<div class="src-filter">
		               	    <div class="card card-primary">

		               	    	<div class="row"> 
									        <div class="col-lg-4 col-6">
									          <!-- small box -->
									          <div class="small-box bg-warning">
									            <div class="inner">
									              <h3>{{ $data['unaprov_user'] }}</h3>

									              <p>{{ __("messages.Unapproved user") }}</p>
									            </div>
									            <div class="icon">
									              <i class="ion ion-person-add"></i>
									            </div>
									          </div>
									        </div>


									        <div class="col-lg-4 col-6">
									          <!-- small box -->
									          <div class="small-box bg-green color-palette">
									            <div class="inner">
									              <h3>{{ $data['total_user'] }}</h3>

									              <p>{{ __("messages.All user") }}</p>
									            </div>
									            <div class="icon">
									             <i class="ion ion-person-add" style="color: #fff;"></i>
									            </div>
									          </div>
									        </div>
									        <div class="col-lg-4 col-6">
									          <!-- small box -->
									          <div class="small-box bg-danger color-palette">
									            <div class="inner">
									              <h3>{{ $data['block_user'] }}</h3>

									              <p>{{ __("messages.Blocked Users") }}</p>
									            </div>
									            <div class="icon">
									          <i class="ion ion-person-add"></i>
									            </div>
									          </div>
									        </div>
									        <!-- ./col -->
									          
									      </div>


					            <div class="card-header">
					              <h3 class="card-title">{{ __('messages.User Filter')}}</h3>

					              <div class="card-tools">
					                <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
					                  <i class="fas fa-minus"></i>
					                </button>
					              </div>
					            </div>
					            <div class="card-body">
					            	{{ Form::open(array("url"=>"admin/newUser",'method' => 'get')) }}
						              
						              <div class="row">
						              	<div class="col-md-3">
						                      <div class="form-group">
        						                {{Form::label("name",__('messages.Fullname'))}}
        		                              	<input type="text" class="form-control" name="fullname" value="@php if(isset($_GET['fullname'])) echo $_GET['fullname']; @endphp">
        						              </div>
						                  </div>
						                  <div class="col-md-3">
						                      <div class="form-group">
        						                {{Form::label("status",__('messages.Email'))}}
        	                       				<input type="text" name="email" value="@php if(isset($_GET["email"])){  echo $_GET["email"];  }  @endphp" class="form-control">
        						              </div>
						                  </div>
						                  <div class="col-md-3">
						                      <div class="form-group">
        						                {{Form::label("status",__('messages.Telephone Number'))}}
        	                       				<input type="text" name="telephone" value="@php if(isset($_GET["telephone"])){  echo $_GET["telephone"];  }  @endphp" class="form-control">
        						              </div>
						                  </div>
						                  <div class="col-md-3">
						                      <div class="form-group">
					                            {{Form::label("add_from_to",__('messages.Register From-To date'))}}
                                                <div class="input-group">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">
                                                            <i class="far fa-calendar-alt"></i>
                                                        </span>
                                                    </div>
                                                    <input autocomplete="off" type="text" class="form-control float-right" id="add_from_to" name="add_from_to">
                                                </div>
                                                <!-- /.input group -->
                                            </div>
						                  </div>
						              	<div class="col-12">
								          <a href="{{url('admin/newUser')}}" class="btn btn-danger">{{ __('messages.Reset') }}</a>
									          {{ Form::submit(__('messages.Search'),['name' => 'searchsubmit', "class"=>"btn btn-warning"]) }}
					                            
					                         {{ Form::submit(__('messages.Export'),['name' => 'exportsubmit', "class"=>"btn btn-success"]) }}
					                         
								        </div>
								    </div>
							        {{ Form::close() }}
					            </div>
					            <!-- /.card-body -->
				          	</div>
		                </div>	
		                <table id="myTable" class="table table-bordered table-striped">
		                  <thead>
		                  <tr>
		                    <th>{{ __('messages.ID')}}</th>
		                    <th>{{ __('messages.Fullname') }}</th>
		                    <th>{{ __('messages.Email') }}</th>
		                    <th>{{ __('messages.Telephone Number') }}</th>
		                    <th>{{ __('messages.Registered date') }}</th>
		                    <th style="width: 8%" class="text-center">
		                        {{__('messages.Status')}}
		                    </th>
		                    <th style="width: 20%">
		                    	{{__('messages.Action')}}
		                    </th>
		                  </tr>
		                  </thead>
		                  <tbody>
		                  	@php $x= 1; @endphp
	                		@forelse($userList as $userValue)
	                		@php $id = Crypt::encryptString($userValue->id); @endphp
	                		<tr>
			                  <td>{{$userValue->id}}</td>
			                  <td>{{$userValue->fullname}}</td>
			                  <td>{{$userValue->email}}</td>
			                  <td>{{$userValue->mobNumber}}</td>
			                  
			                  <td>{{date("d/m/Y",strtotime($userValue->created_at))}}</td>
			                  <td>
			                  	@if($userValue->status == 0)<span class="badge badge-warning"> {{ __('messages.Hold')}}</span>
			                  	@elseif($userValue->status == 2)<span class="badge badge-success"> {{ __('messages.Approved')}}</span>
			                  	@elseif($userValue->status == 1)<span class="badge badge-danger"> {{ __('messages.Unapproved')}}</span>
			                  	@endif
			                  </td>
			                  <td>
			                  	@php 
				                 
				                  $s_1 = Crypt::encryptString("1");
				                  $s_2 = Crypt::encryptString("2");
				                  $s_3 = Crypt::encryptString("3");

				                  $tablename = Crypt::encryptString("users");
				                  #$tablename = "users";
				                  @endphp

			                  	
			                  	@if($userValue->status == 0) 
			                  		<a class="btn btn-success btn-sm" href="javascript:void(0)" onclick="Caidf('@php echo $id; @endphp','@php echo $s_2; @endphp','cudhuegdnbav','newUser','@php echo $tablename; @endphp')">
		                  	        {{ __('messages.Approve User')}}</a>  
			                  	    <a class="btn btn-danger btn-sm" href="javascript:void(0)" onclick="Caidf('@php echo $id; @endphp','@php echo $s_1; @endphp','cudhuegdnbav','newUser','@php echo $tablename; @endphp')">{{ __('messages.Unapprove User')}}</a>
			                  	    </a>
			                  	@endif
			                  	 <a  class="btn btn-info btn-sm" href="{{ url('admin/editUser').'/'.$id }}"><i class="fas fa-pencil-alt">
		                              </i>{{ __('messages.editUser')}}</a>
			                  <a class="btn btn-primary btn-sm" href="{{ url('admin/userDetail').'/'.$id }}"><i class="fas fa-folder">
		                              </i>
		                              View</a>
	                		</tr>
	                		@php $x++; @endphp
	                		@empty
                			{{--<p>{{ __('messages.no_record')}}</p>--}}

	                		@endforelse
			                    
		                  </tbody>
		                  <tfoot>
		                  <tr>
		                    <th>{{__('messages.ID')}}</th>
		                    <th>{{ __('messages.Fullname') }}</th>
		                    <th>{{ __('messages.Email') }}</th>
		                    <th>{{ __('messages.Telephone Number') }}</th>
		                    <th>{{ __('messages.Registered date') }}</th>
		                    <th style="width: 8%" class="text-center">
		                        {{ __('messages.Status') }}
		                    </th>
		                    <th style="width: 20%">
		                    	{{ __('messages.Action') }}
		                    </th>
		                  </tr>
		                  </tfoot>
		                </table>
		                 @if(count($userList)>0)
		            	<div class="pagination-link">{{$userList->links()}}</div>
		            	@endif
		              </div>
		              <!-- /.card-body -->
		            </div>
		        </div>
	    	</div>
		</div>
	</section>

@include("admin.template.footer")
<script>
$(function () {
    $("#myTable").DataTable({
    	aaSorting : [[0, 'desc']],
        "responsive": true,
        "autoWidth": false,
        "language": {
            "emptyTable": "{{ __('messages.no_record')}}"
        },
        
        "searching": false,   // Search Box will Be Disabled
        "ordering": false,    // Ordering (Sorting on Each Column)will Be Disabled
        "info": true,         // Will show "1 to n of n entries" Text at bottom
        "lengthChange": false // Will Disabled Record number per page
    });
});
</script>