@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
   <section class="content">
       <div class="container-fluid">
       <!-- Small boxes (Stat box) -->
         <div class="row">
            <div class="col-md-12">
               {!! session("message") !!}
            </div>   
            <div class="col-md-12">
               <div class="card">
                  <!-- /.card-header -->
                  <div class="card-body">
                     <div class="src-filter">
                        <div class="card card-primary">
                           
                           <!-- /.card-body -->
                        </div>
                     </div>  
                     <table id="myTable" class="table table-bordered table-striped">
                        <thead>
                            <tr>
                              <th>{{ __('messages.ID')}}</th>
                              <th style="width: 8%" class="text-center">
                                 {{ __('messages.Order Id')}}
                              </th>
                              <th>{{ __('messages.Device Id')}}</th>
                              <th>{{ __('messages.Battery Id')}}</th>
                              <th>{{ __('messages.Rental Status')}}</th>
                              <th>{{ __('messages.Order Status')}}</th>
                              <th>{{ __('messages.Rental Time')}}</th>
                              <th>{{ __('messages.Return time')}}</th>
                              <th>{{ __('messages.Deposit amount')}}</th>
                              <th>{{ __('messages.Order amount')}}</th>
                              <th>{{ __('messages.Action')}}</th>
                            </tr>
                        </thead>
                        <tbody>
                           @php $x= 1; @endphp
                           @forelse($data["orderList"] as $value)
                           @php $id = Crypt::encryptString($value->id); @endphp
                            <tr>
                                <td>{{$value->id}}</td>
                                <td>{{$value->order_id}}</td>
                                <td><a href="{{url('admin/listBatteries?deviceId='.$value->device_id.'&searchsubmit=Search')}}">{{$value->device_id}}</a></td>
                                <td>{{$value->battery_id}}</td>
                                <td>
                                    @if($value->rental_status === '1')
                                    <span class="bg-success">{{__('messages.Success')}}</span>
                                    @elseif($value->rental_status === '0')
                                    <span class="bg-danger">{{__('messages.Failure')}}</span>
                                    @endif
                                </td>
                              <td></td>
                              <td>{{$value->rented_time}}</td>
                              <td>{{$value->return_time}}</td>
                              <td>{{$value->deposit_amount}}</td>
                              <td></td>
                              <td></td>
                           </tr>
                           @php $x++; @endphp
                           @empty
                           {{--<p>{{ __('messages.no_record')}}</p>--}}

                           @endforelse     
                        </tbody>
                        <tfoot>
                        <tr>
                            <th>{{ __('messages.ID')}}</th>
                            <th style="width: 8%" class="text-center">
                                 {{ __('messages.Order Id')}}
                            </th>
                            <th>{{ __('messages.Device Id')}}</th>
                            <th>{{ __('messages.Battery Id')}}</th>
                            <th>{{ __('messages.Rental Status')}}</th>
                            <th>{{ __('messages.Order Status')}}</th>
                            <th>{{ __('messages.Rental Time')}}</th>
                            <th>{{ __('messages.Return time')}}</th>
                            <th>{{ __('messages.Deposit amount')}}</th>
                            <th>{{ __('messages.Order amount')}}</th>
                            <th>{{ __('messages.Action')}}</th>
                        </tr>
                        </tfoot>
                     </table>
                     @if(!empty($data["orderList"]))
                     {{$data["orderList"]->appends(request()->input())->links()}}
                     @endif 
                  </div>
              </div>
         </div>
      </div>
   </section>

@include("admin.template.footer")
<script>
$(function () {
    $("#myTable").DataTable({
        aaSorting : [[0, 'desc']],
        "responsive": true,
        "autoWidth": false,
        "language": {
            "emptyTable": "{{ __('messages.no_record')}}"
        },
        
        "searching": false,   // Search Box will Be Disabled
        "ordering": false,    // Ordering (Sorting on Each Column)will Be Disabled
        "info": true,         // Will show "1 to n of n entries" Text at bottom
        "lengthChange": false // Will Disabled Record number per page
    });
});
</script>