@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
	<section class="content">
	    <div class="container-fluid">
	    <!-- Small boxes (Stat box) -->
	    	<div class="row">
	    		<div class="col-md-12">
      				{!! session("message") !!}
      			</div>	
	    		<div class="col-md-12">
			    	<div class="card">
		              <!-- /.card-header -->
		              <div class="card-body">
		              		<div class="card card-primary">
					            <div class="card-header">
					              <h3 class="card-title">{{$data['heading']}}</h3>

					              <div class="card-tools">
					                <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
					                  <i class="fas fa-minus"></i>
					                </button>
					              </div>
					            </div>
					            <div class="card-body">
					              	{{Form::open(array("url"=>"admin/kioskSubmit","method"=>"post","files"=>"true"))}}
					              	{{Form::hidden("id",$data['record']->id,["class"=>"form-control"])}}
					              	{{Form::hidden("old_image",$data['record']->image,["class"=>"form-control"])}}
							            <div class="form-group">
							               <label for="inputName">{{ __('messages.Device Id')}}</label>
							               {{Form::text("",$data['record']->device_id,["class"=>"form-control","disabled"])}}
							            </div>
							            <div class="form-group">
							               <label for="inputName">{{ __('messages.Location')}}</label>
							               {{Form::text("",$data['record']->device_address,["class"=>"form-control","disabled"])}}
							            </div>

							            <div class="form-group">
							               <label for="inputName">{{ __('messages.Device Type')}} [5=5 port device]</label>
							               {{Form::text("",$data['record']->device_type,["class"=>"form-control","disabled"])}}
							            </div>
							            <div class="row">
                                   	        <div class="col-6">
						               		<label for="inputName">{{ __('messages.Location name')}}</label>
						               		{{Form::text("location_name",$data['record']->location_name,["class"=>"form-control"])}}
						               		<div class="error">{{$errors->first("location_name")}}</div>
							            	</div>
								            <div class="col-6">
								               <label for="inputName">{{ __('messages.Contact number')}}</label>
								               {{Form::text("contact_number",$data['record']->contact_number,["class"=>"form-control"])}}
								               <div class="error">{{$errors->first("contact_number")}}</div>
								            </div>
								            
								        	</div>
							            <div class="row">
                                   	<div class="col-6">
                                       <label for=" ">{{ __('messages.Opening time')}}</label>
                                   
                                       <div class="input-group date" id="opening_time" data-target-input="nearest">
                                       {{Form::text("opening_time",$data['record']->opening_time,["class"=>"timepicker form-control datetimepicker-input","data-target"=>"#opening_time"])}}
                                       <div class="input-group-append" data-target="#opening_time" data-toggle="datetimepicker">
                                         <div class="input-group-text"><i class="far fa-clock"></i></div>
                                       </div>
                                       </div>
                                       <div class="error">{{ $errors->first('opening_time') }}</div>
                                  	</div>

                                   	<div class="col-6">
                                       <label for=" ">{{ __('messages.Closing time')}}</label>
                                   
                                       <div class="input-group date" id="closing_time" data-target-input="nearest">
                                       {{Form::text("closing_time",$data['record']->closing_time,["class"=>"timepicker form-control datetimepicker-input","data-target"=>"#closing_time"])}}
                                       <div class="input-group-append" data-target="#closing_time" data-toggle="datetimepicker">
                                      	<div class="input-group-text"><i class="far fa-clock"></i></div>
                                       </div>
                                    	</div>
                                    	<div class="error">{{ $errors->first('closing_time') }}</div>
                                   	</div>
                               	</div>
				            			<div class="form-group">
			                        	{{Form::label("status",__('messages.Image'))}}
				                       	<input type="file" name="image">
				                       	@if(!empty($data['record']->image))
				                       	<img src="{{ url('public/upload/kioskProfile').'/'.$data['record']->image }}" height="80" width="80">
				                       	@endif
				                       	<div class="error">{{ $errors->first('image') }}</div>
					                	</div>
							            
						              	<div class="col-12">
								          <a href="{{ url('admin/kioskList') }}" class="btn btn-secondary">{{ __('messages.Cancel')}}</a>
								          <input type="submit" value="{{ __('messages.Submit') }}" class="btn btn-success float-right">
								        </div>
							        {{Form::close()}}
					            </div>
					            <!-- /.card-body -->
				          </div>
		              </div>
		              <!-- /.card-body -->
		            </div>
		        </div>
	    	</div>
		</div>
	</section>

@include("admin.template.footer")
