@include("admin.template.header")
@include("admin.template.sidebar")

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$data['heading']}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{url('admin/dashboard')}}">{{ __('messages.Dashboard')}}</a></li>
              <li class="breadcrumb-item active">{{$data['heading']}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
        <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
            <div class="row">
                <div class="col-md-12">
                    {!! session("message") !!}
                </div>  
                <div class="col-md-12">
                    <div class="card">
                      <!-- /.card-header -->
                      <div class="card-body">
                        @if(count($data["record"])>0)
                        @php $id = Crypt::encryptString($data["record"][0]["id"]); @endphp
                            <table class="table">
                               <thead>
                                  <tr>
                                    <th>{{__('messages.Label')}}</th>
                                    <th>{{__('messages.Value')}}</th>
                                  </tr>
                               </thead>
                               <tbody>
                                  <tr>
                                     <td>{{__('messages.Fullname')}}</td>
                                     <td>{{ $data["record"][0]["fullname"] }}</td>
                                  </tr>
                                  <tr>
                                     <td>{{__('messages.Email')}}</td>
                                     <td>{{ $data["record"][0]["email"] }}</td>
                                  </tr>
                                  <tr>
                                     <td>{{__('messages.Telephone Number')}}</td>
                                     <td>{{ $data["record"][0]["mobNumber"] }}</td>
                                  </tr>
                                  {{--<tr>
                                     <td>{{__('messages.Gender')}}</td>
                                     <td>
                                        @if($data["record"][0]["gender"] == "M") {{ __('messages.Male')}}
                                        @elseif($data["record"][0]["status"] == "F") {{ __('messages.Female')}}
                                        @endif
                                     </td>
                                  </tr>--}}
                                  <tr>
                                     <td>{{__('messages.Registered date')}}</td>
                                     <td>{{ date("d/m/Y", strtotime($data["record"][0]["created_at"]) ) }}</td>
                                  </tr>
                                  <tr>
                                     <td>{{__('messages.Status')}}</td>
                                     <td>
                                        @if($data["record"][0]["status"] == 0) {{ __('messages.Hold')}}
                                        @elseif($data["record"][0]["status"] == 1) {{ __('messages.Approved')}}
                                        @elseif($data["record"][0]["status"] == 2) {{ __('messages.Unapproved')}}
                                        @elseif($data["record"][0]["status"] == 3) {{ __('messages.Blocked')}}
                                        @endif
                                     </td>
                                  </tr>
                                  <tr>
                                     <td>{{__('messages.Image')}}</td>
                                     <td>
                                        @if(!empty($data["record"][0]["image"]))
                                        @php
                                        $destinationPath = public_path('/upload/usersProfile');
                                        $file_pointer = $destinationPath.'/'.$data["record"][0]["image"];
                                        if (file_exists($file_pointer)){
                                        @endphp
                                        <div class="timeline-item">
                                           <div class="timeline-body">
                                              <img  alt="User image" height="150" width="150" src="{{ url('public/upload/usersProfile').'/'.$data["record"][0]["image"]}}">
                                           </div>
                                        </div>
                                        @php } @endphp
                                        @endif
                                     </td>
                                  </tr>
                               </tbody>
                            </table>
                        @endif
                                    
                      </div>
                      <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>

@include("admin.template.footer")