<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

/* Admin Routes */
Route::middleware(["CheckLogin"])->group(function(){
	Route::view('login',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
	Route::view('admin',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
	Route::post('admin/LoginSubmit', "admin\AdminController@LoginSubmit");
});
/*******/

Route::get('admin/logout', "admin\AdminController@logout");
Route::prefix("admin")->group(function(){
	Route::middleware(["AdminCheck"])->group(function(){
		
		Route::get("cudhuegdnbav/{id}/{status}/{callback}/{table}","admin\AdminController@CommonAed");
		Route::get('dashboard',"admin\AdminController@dashboard");
		
		/* User routes */
		Route::match(["get","post"],"allUser","admin\AdminUserController@allUser");
		Route::match(["get","post"],"blockedUser","admin\AdminUserController@blockedUser");
		Route::match(["get","post"],"newUser","admin\AdminUserController@newUser");
		Route::match(["get"],"userDetail/{id}","admin\AdminUserController@userDetail");
		Route::match(["get"],"resetUserPass/{id}","admin\AdminUserController@resetUserPass");
		Route::match(["post"],"userPassSubmit","admin\AdminUserController@userPassSubmit");

		/* Subadmin Routes */
		Route::get("allsubadmin","admin\AdminController@allsubadmin"); 
		Route::get("addsubadmin","admin\AdminController@addsubadmin");
		Route::post("subadminSubmit","admin\AdminController@subadminSubmit");
		Route::get("editsubadmin/{id}","admin\AdminController@editsubadmin");
		Route::post("editsubadminSubmit","admin\AdminController@editsubadminSubmit");

		/* Email notification */
		Route::match(["get"],"sendEmailNotification/{names}","admin\AdminController@sendEmailNotification")->where('names', '[A-Za-z]+');
		Route::match(["post"],"sendEmailNotificationSubmit","admin\AdminController@sendEmailNotificationSubmit");

		/* Page Routes */
		Route::get("privacyPolicy","admin\PageSettingController@privacyPolicy");
		Route::post("privacyPolicySubmit","admin\PageSettingController@privacyPolicySubmit");
		Route::get("termsCondition","admin\PageSettingController@termsCondition");
		Route::post("termsConditionSubmit","admin\PageSettingController@termsConditionSubmit");
		Route::get("listFaq","admin\FaqController@listFaq");
		Route::get("addfaq","admin\FaqController@addfaq");
		Route::post("addFaqSubmit","admin\FaqController@addFaqSubmit");
		Route::get("editFaq/{id}","admin\FaqController@editFaq");
		Route::post("editFaqSubmit","admin\FaqController@editFaqSubmit");
		Route::get("deleteFaq/{id}","admin\FaqController@deleteFaq");

		/* Payment setting Routes */
		Route::match(["get"],"paymentSetting","admin\AdminController@paymentSetting");
		Route::match(["post"],"stripeSettingSubmit","admin\AdminController@stripeSettingSubmit");
		Route::match(["post"],"paypalSettingSubmit","admin\AdminController@paypalSettingSubmit");

		/* Admin password reset Routes */
		Route::get("adminPassReset","admin\AdminController@adminPassReset");
		Route::post("adminPassSubmit","admin\AdminController@adminPassSubmit");

		/* Site setting Routes */
		Route::get("siteSetting","admin\AdminController@siteSetting");
		Route::post("siteSettingsubmit","admin\AdminController@siteSettingSubmit");

		/* Coupon code management */
		Route::get("addCoupon","admin\AdminController@addCoupon");
		Route::get("listCoupon","admin\AdminController@listCoupon");
		Route::post("addCouponSubmit","admin\AdminController@addCouponSubmit");

		/* Kiosk management */
		Route::get("kioskList","admin\KioskController@kioskList");
		Route::get("updateKioskInfo/{id}","admin\KioskController@updateKioskInfo");
		Route::post("kioskSubmit","admin\KioskController@kioskSubmit");
		
		/* Battery management */
		Route::get("listBatteries","admin\BatteryController@listBatteries");
		/************/
		
		/* Order management */
		Route::get("allRental","admin\OrderController@allRental");
		Route::get("currentRental","admin\OrderController@currentRental");
		Route::get("pastRental","admin\OrderController@pastRental");
		
	});
});

/* IoT Functionality */
Route::get("registerDevice","IoT\IotController@registerDevice");
Route::get("hearBeat","IoT\IotController@hearBeat");
Route::get("shortHearBeat","IoT\IotController@shortHearBeat");



/* Paypal payment */
Route::get("paypalAuth","PaymentController@paypalAuth");
Route::get('kiosk/payment/{id1}/{id2}/{amount}','PaymentController@kioskPaypal');
Route::get('updateKioskSuccess','PaymentController@updateKioskSuccess');
Route::get('updateKioskSuccess1','PaymentController@updateKioskSuccess1');
Route::get('updateKioskCancel','PaymentController@updateKioskCancel');
/************/

/* Stripe payment */
Route::get('stripe/{id1}/{id2}/{amount}','PaymentController@stripe');
Route::post('orderPaymentResponse', 'PaymentController@stripePost')->name('stripe.post');
Route::get('orderPaymentback', 'PaymentController@orderPaymentback');
Route::get('orderStripeCancel', 'PaymentController@orderStripeCancel');
Route::get('orderStripeSuccess', 'PaymentController@orderStripeSuccess');

/************/
